
package com.dremio.exec.expr.fn.impl;

import java.nio.charset.Charset;

import javax.inject.Inject;

import org.apache.arrow.vector.holders.NullableVarCharHolder;

import com.dremio.exec.expr.SimpleFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.annotations.Workspace;
import com.dremio.exec.expr.annotations.FunctionTemplate.FunctionScope;
import com.dremio.exec.expr.annotations.FunctionTemplate.NullHandling;

import org.apache.arrow.memory.ArrowBuf;

/**
 * Freemarker generated from template ConcatFunctions.java
 */
public class ConcatFunctions {

  public static final int CONCAT_MAX_ARGS = 10;

  private ConcatFunctions() {}

  @FunctionTemplate(name = "concat", scope = FunctionScope.SIMPLE, nulls = NullHandling.INTERNAL)
  public static class Concat2 implements SimpleFunction {

    @Param NullableVarCharHolder arg1;
    @Param NullableVarCharHolder arg2;
    @Output NullableVarCharHolder out;
    @Inject ArrowBuf buffer;

    @Override
    public void setup() {
    }

    @Override
    public void eval() {
      int size = 0;
      size += (arg1.end - arg1.start);
      size += (arg2.end - arg2.start);
      buffer = buffer.reallocIfNeeded(size);
      out.buffer = buffer;
      out.start = out.end = 0;
      out.isSet = 1;

      if (arg1.isSet == 1) {
        for (int id = arg1.start; id < arg1.end; id++) {
          out.buffer.setByte(out.end++, arg1.buffer.getByte(id));
        }
      }
      if (arg2.isSet == 1) {
        for (int id = arg2.start; id < arg2.end; id++) {
          out.buffer.setByte(out.end++, arg2.buffer.getByte(id));
        }
      }
    }
  }
  @FunctionTemplate(name = "concat", scope = FunctionScope.SIMPLE, nulls = NullHandling.INTERNAL)
  public static class Concat3 implements SimpleFunction {

    @Param NullableVarCharHolder arg1;
    @Param NullableVarCharHolder arg2;
    @Param NullableVarCharHolder arg3;
    @Output NullableVarCharHolder out;
    @Inject ArrowBuf buffer;

    @Override
    public void setup() {
    }

    @Override
    public void eval() {
      int size = 0;
      size += (arg1.end - arg1.start);
      size += (arg2.end - arg2.start);
      size += (arg3.end - arg3.start);
      buffer = buffer.reallocIfNeeded(size);
      out.buffer = buffer;
      out.start = out.end = 0;
      out.isSet = 1;

      if (arg1.isSet == 1) {
        for (int id = arg1.start; id < arg1.end; id++) {
          out.buffer.setByte(out.end++, arg1.buffer.getByte(id));
        }
      }
      if (arg2.isSet == 1) {
        for (int id = arg2.start; id < arg2.end; id++) {
          out.buffer.setByte(out.end++, arg2.buffer.getByte(id));
        }
      }
      if (arg3.isSet == 1) {
        for (int id = arg3.start; id < arg3.end; id++) {
          out.buffer.setByte(out.end++, arg3.buffer.getByte(id));
        }
      }
    }
  }
  @FunctionTemplate(name = "concat", scope = FunctionScope.SIMPLE, nulls = NullHandling.INTERNAL)
  public static class Concat4 implements SimpleFunction {

    @Param NullableVarCharHolder arg1;
    @Param NullableVarCharHolder arg2;
    @Param NullableVarCharHolder arg3;
    @Param NullableVarCharHolder arg4;
    @Output NullableVarCharHolder out;
    @Inject ArrowBuf buffer;

    @Override
    public void setup() {
    }

    @Override
    public void eval() {
      int size = 0;
      size += (arg1.end - arg1.start);
      size += (arg2.end - arg2.start);
      size += (arg3.end - arg3.start);
      size += (arg4.end - arg4.start);
      buffer = buffer.reallocIfNeeded(size);
      out.buffer = buffer;
      out.start = out.end = 0;
      out.isSet = 1;

      if (arg1.isSet == 1) {
        for (int id = arg1.start; id < arg1.end; id++) {
          out.buffer.setByte(out.end++, arg1.buffer.getByte(id));
        }
      }
      if (arg2.isSet == 1) {
        for (int id = arg2.start; id < arg2.end; id++) {
          out.buffer.setByte(out.end++, arg2.buffer.getByte(id));
        }
      }
      if (arg3.isSet == 1) {
        for (int id = arg3.start; id < arg3.end; id++) {
          out.buffer.setByte(out.end++, arg3.buffer.getByte(id));
        }
      }
      if (arg4.isSet == 1) {
        for (int id = arg4.start; id < arg4.end; id++) {
          out.buffer.setByte(out.end++, arg4.buffer.getByte(id));
        }
      }
    }
  }
  @FunctionTemplate(name = "concat", scope = FunctionScope.SIMPLE, nulls = NullHandling.INTERNAL)
  public static class Concat5 implements SimpleFunction {

    @Param NullableVarCharHolder arg1;
    @Param NullableVarCharHolder arg2;
    @Param NullableVarCharHolder arg3;
    @Param NullableVarCharHolder arg4;
    @Param NullableVarCharHolder arg5;
    @Output NullableVarCharHolder out;
    @Inject ArrowBuf buffer;

    @Override
    public void setup() {
    }

    @Override
    public void eval() {
      int size = 0;
      size += (arg1.end - arg1.start);
      size += (arg2.end - arg2.start);
      size += (arg3.end - arg3.start);
      size += (arg4.end - arg4.start);
      size += (arg5.end - arg5.start);
      buffer = buffer.reallocIfNeeded(size);
      out.buffer = buffer;
      out.start = out.end = 0;
      out.isSet = 1;

      if (arg1.isSet == 1) {
        for (int id = arg1.start; id < arg1.end; id++) {
          out.buffer.setByte(out.end++, arg1.buffer.getByte(id));
        }
      }
      if (arg2.isSet == 1) {
        for (int id = arg2.start; id < arg2.end; id++) {
          out.buffer.setByte(out.end++, arg2.buffer.getByte(id));
        }
      }
      if (arg3.isSet == 1) {
        for (int id = arg3.start; id < arg3.end; id++) {
          out.buffer.setByte(out.end++, arg3.buffer.getByte(id));
        }
      }
      if (arg4.isSet == 1) {
        for (int id = arg4.start; id < arg4.end; id++) {
          out.buffer.setByte(out.end++, arg4.buffer.getByte(id));
        }
      }
      if (arg5.isSet == 1) {
        for (int id = arg5.start; id < arg5.end; id++) {
          out.buffer.setByte(out.end++, arg5.buffer.getByte(id));
        }
      }
    }
  }
  @FunctionTemplate(name = "concat", scope = FunctionScope.SIMPLE, nulls = NullHandling.INTERNAL)
  public static class Concat6 implements SimpleFunction {

    @Param NullableVarCharHolder arg1;
    @Param NullableVarCharHolder arg2;
    @Param NullableVarCharHolder arg3;
    @Param NullableVarCharHolder arg4;
    @Param NullableVarCharHolder arg5;
    @Param NullableVarCharHolder arg6;
    @Output NullableVarCharHolder out;
    @Inject ArrowBuf buffer;

    @Override
    public void setup() {
    }

    @Override
    public void eval() {
      int size = 0;
      size += (arg1.end - arg1.start);
      size += (arg2.end - arg2.start);
      size += (arg3.end - arg3.start);
      size += (arg4.end - arg4.start);
      size += (arg5.end - arg5.start);
      size += (arg6.end - arg6.start);
      buffer = buffer.reallocIfNeeded(size);
      out.buffer = buffer;
      out.start = out.end = 0;
      out.isSet = 1;

      if (arg1.isSet == 1) {
        for (int id = arg1.start; id < arg1.end; id++) {
          out.buffer.setByte(out.end++, arg1.buffer.getByte(id));
        }
      }
      if (arg2.isSet == 1) {
        for (int id = arg2.start; id < arg2.end; id++) {
          out.buffer.setByte(out.end++, arg2.buffer.getByte(id));
        }
      }
      if (arg3.isSet == 1) {
        for (int id = arg3.start; id < arg3.end; id++) {
          out.buffer.setByte(out.end++, arg3.buffer.getByte(id));
        }
      }
      if (arg4.isSet == 1) {
        for (int id = arg4.start; id < arg4.end; id++) {
          out.buffer.setByte(out.end++, arg4.buffer.getByte(id));
        }
      }
      if (arg5.isSet == 1) {
        for (int id = arg5.start; id < arg5.end; id++) {
          out.buffer.setByte(out.end++, arg5.buffer.getByte(id));
        }
      }
      if (arg6.isSet == 1) {
        for (int id = arg6.start; id < arg6.end; id++) {
          out.buffer.setByte(out.end++, arg6.buffer.getByte(id));
        }
      }
    }
  }
  @FunctionTemplate(name = "concat", scope = FunctionScope.SIMPLE, nulls = NullHandling.INTERNAL)
  public static class Concat7 implements SimpleFunction {

    @Param NullableVarCharHolder arg1;
    @Param NullableVarCharHolder arg2;
    @Param NullableVarCharHolder arg3;
    @Param NullableVarCharHolder arg4;
    @Param NullableVarCharHolder arg5;
    @Param NullableVarCharHolder arg6;
    @Param NullableVarCharHolder arg7;
    @Output NullableVarCharHolder out;
    @Inject ArrowBuf buffer;

    @Override
    public void setup() {
    }

    @Override
    public void eval() {
      int size = 0;
      size += (arg1.end - arg1.start);
      size += (arg2.end - arg2.start);
      size += (arg3.end - arg3.start);
      size += (arg4.end - arg4.start);
      size += (arg5.end - arg5.start);
      size += (arg6.end - arg6.start);
      size += (arg7.end - arg7.start);
      buffer = buffer.reallocIfNeeded(size);
      out.buffer = buffer;
      out.start = out.end = 0;
      out.isSet = 1;

      if (arg1.isSet == 1) {
        for (int id = arg1.start; id < arg1.end; id++) {
          out.buffer.setByte(out.end++, arg1.buffer.getByte(id));
        }
      }
      if (arg2.isSet == 1) {
        for (int id = arg2.start; id < arg2.end; id++) {
          out.buffer.setByte(out.end++, arg2.buffer.getByte(id));
        }
      }
      if (arg3.isSet == 1) {
        for (int id = arg3.start; id < arg3.end; id++) {
          out.buffer.setByte(out.end++, arg3.buffer.getByte(id));
        }
      }
      if (arg4.isSet == 1) {
        for (int id = arg4.start; id < arg4.end; id++) {
          out.buffer.setByte(out.end++, arg4.buffer.getByte(id));
        }
      }
      if (arg5.isSet == 1) {
        for (int id = arg5.start; id < arg5.end; id++) {
          out.buffer.setByte(out.end++, arg5.buffer.getByte(id));
        }
      }
      if (arg6.isSet == 1) {
        for (int id = arg6.start; id < arg6.end; id++) {
          out.buffer.setByte(out.end++, arg6.buffer.getByte(id));
        }
      }
      if (arg7.isSet == 1) {
        for (int id = arg7.start; id < arg7.end; id++) {
          out.buffer.setByte(out.end++, arg7.buffer.getByte(id));
        }
      }
    }
  }
  @FunctionTemplate(name = "concat", scope = FunctionScope.SIMPLE, nulls = NullHandling.INTERNAL)
  public static class Concat8 implements SimpleFunction {

    @Param NullableVarCharHolder arg1;
    @Param NullableVarCharHolder arg2;
    @Param NullableVarCharHolder arg3;
    @Param NullableVarCharHolder arg4;
    @Param NullableVarCharHolder arg5;
    @Param NullableVarCharHolder arg6;
    @Param NullableVarCharHolder arg7;
    @Param NullableVarCharHolder arg8;
    @Output NullableVarCharHolder out;
    @Inject ArrowBuf buffer;

    @Override
    public void setup() {
    }

    @Override
    public void eval() {
      int size = 0;
      size += (arg1.end - arg1.start);
      size += (arg2.end - arg2.start);
      size += (arg3.end - arg3.start);
      size += (arg4.end - arg4.start);
      size += (arg5.end - arg5.start);
      size += (arg6.end - arg6.start);
      size += (arg7.end - arg7.start);
      size += (arg8.end - arg8.start);
      buffer = buffer.reallocIfNeeded(size);
      out.buffer = buffer;
      out.start = out.end = 0;
      out.isSet = 1;

      if (arg1.isSet == 1) {
        for (int id = arg1.start; id < arg1.end; id++) {
          out.buffer.setByte(out.end++, arg1.buffer.getByte(id));
        }
      }
      if (arg2.isSet == 1) {
        for (int id = arg2.start; id < arg2.end; id++) {
          out.buffer.setByte(out.end++, arg2.buffer.getByte(id));
        }
      }
      if (arg3.isSet == 1) {
        for (int id = arg3.start; id < arg3.end; id++) {
          out.buffer.setByte(out.end++, arg3.buffer.getByte(id));
        }
      }
      if (arg4.isSet == 1) {
        for (int id = arg4.start; id < arg4.end; id++) {
          out.buffer.setByte(out.end++, arg4.buffer.getByte(id));
        }
      }
      if (arg5.isSet == 1) {
        for (int id = arg5.start; id < arg5.end; id++) {
          out.buffer.setByte(out.end++, arg5.buffer.getByte(id));
        }
      }
      if (arg6.isSet == 1) {
        for (int id = arg6.start; id < arg6.end; id++) {
          out.buffer.setByte(out.end++, arg6.buffer.getByte(id));
        }
      }
      if (arg7.isSet == 1) {
        for (int id = arg7.start; id < arg7.end; id++) {
          out.buffer.setByte(out.end++, arg7.buffer.getByte(id));
        }
      }
      if (arg8.isSet == 1) {
        for (int id = arg8.start; id < arg8.end; id++) {
          out.buffer.setByte(out.end++, arg8.buffer.getByte(id));
        }
      }
    }
  }
  @FunctionTemplate(name = "concat", scope = FunctionScope.SIMPLE, nulls = NullHandling.INTERNAL)
  public static class Concat9 implements SimpleFunction {

    @Param NullableVarCharHolder arg1;
    @Param NullableVarCharHolder arg2;
    @Param NullableVarCharHolder arg3;
    @Param NullableVarCharHolder arg4;
    @Param NullableVarCharHolder arg5;
    @Param NullableVarCharHolder arg6;
    @Param NullableVarCharHolder arg7;
    @Param NullableVarCharHolder arg8;
    @Param NullableVarCharHolder arg9;
    @Output NullableVarCharHolder out;
    @Inject ArrowBuf buffer;

    @Override
    public void setup() {
    }

    @Override
    public void eval() {
      int size = 0;
      size += (arg1.end - arg1.start);
      size += (arg2.end - arg2.start);
      size += (arg3.end - arg3.start);
      size += (arg4.end - arg4.start);
      size += (arg5.end - arg5.start);
      size += (arg6.end - arg6.start);
      size += (arg7.end - arg7.start);
      size += (arg8.end - arg8.start);
      size += (arg9.end - arg9.start);
      buffer = buffer.reallocIfNeeded(size);
      out.buffer = buffer;
      out.start = out.end = 0;
      out.isSet = 1;

      if (arg1.isSet == 1) {
        for (int id = arg1.start; id < arg1.end; id++) {
          out.buffer.setByte(out.end++, arg1.buffer.getByte(id));
        }
      }
      if (arg2.isSet == 1) {
        for (int id = arg2.start; id < arg2.end; id++) {
          out.buffer.setByte(out.end++, arg2.buffer.getByte(id));
        }
      }
      if (arg3.isSet == 1) {
        for (int id = arg3.start; id < arg3.end; id++) {
          out.buffer.setByte(out.end++, arg3.buffer.getByte(id));
        }
      }
      if (arg4.isSet == 1) {
        for (int id = arg4.start; id < arg4.end; id++) {
          out.buffer.setByte(out.end++, arg4.buffer.getByte(id));
        }
      }
      if (arg5.isSet == 1) {
        for (int id = arg5.start; id < arg5.end; id++) {
          out.buffer.setByte(out.end++, arg5.buffer.getByte(id));
        }
      }
      if (arg6.isSet == 1) {
        for (int id = arg6.start; id < arg6.end; id++) {
          out.buffer.setByte(out.end++, arg6.buffer.getByte(id));
        }
      }
      if (arg7.isSet == 1) {
        for (int id = arg7.start; id < arg7.end; id++) {
          out.buffer.setByte(out.end++, arg7.buffer.getByte(id));
        }
      }
      if (arg8.isSet == 1) {
        for (int id = arg8.start; id < arg8.end; id++) {
          out.buffer.setByte(out.end++, arg8.buffer.getByte(id));
        }
      }
      if (arg9.isSet == 1) {
        for (int id = arg9.start; id < arg9.end; id++) {
          out.buffer.setByte(out.end++, arg9.buffer.getByte(id));
        }
      }
    }
  }
  @FunctionTemplate(name = "concat", scope = FunctionScope.SIMPLE, nulls = NullHandling.INTERNAL)
  public static class Concat10 implements SimpleFunction {

    @Param NullableVarCharHolder arg1;
    @Param NullableVarCharHolder arg2;
    @Param NullableVarCharHolder arg3;
    @Param NullableVarCharHolder arg4;
    @Param NullableVarCharHolder arg5;
    @Param NullableVarCharHolder arg6;
    @Param NullableVarCharHolder arg7;
    @Param NullableVarCharHolder arg8;
    @Param NullableVarCharHolder arg9;
    @Param NullableVarCharHolder arg10;
    @Output NullableVarCharHolder out;
    @Inject ArrowBuf buffer;

    @Override
    public void setup() {
    }

    @Override
    public void eval() {
      int size = 0;
      size += (arg1.end - arg1.start);
      size += (arg2.end - arg2.start);
      size += (arg3.end - arg3.start);
      size += (arg4.end - arg4.start);
      size += (arg5.end - arg5.start);
      size += (arg6.end - arg6.start);
      size += (arg7.end - arg7.start);
      size += (arg8.end - arg8.start);
      size += (arg9.end - arg9.start);
      size += (arg10.end - arg10.start);
      buffer = buffer.reallocIfNeeded(size);
      out.buffer = buffer;
      out.start = out.end = 0;
      out.isSet = 1;

      if (arg1.isSet == 1) {
        for (int id = arg1.start; id < arg1.end; id++) {
          out.buffer.setByte(out.end++, arg1.buffer.getByte(id));
        }
      }
      if (arg2.isSet == 1) {
        for (int id = arg2.start; id < arg2.end; id++) {
          out.buffer.setByte(out.end++, arg2.buffer.getByte(id));
        }
      }
      if (arg3.isSet == 1) {
        for (int id = arg3.start; id < arg3.end; id++) {
          out.buffer.setByte(out.end++, arg3.buffer.getByte(id));
        }
      }
      if (arg4.isSet == 1) {
        for (int id = arg4.start; id < arg4.end; id++) {
          out.buffer.setByte(out.end++, arg4.buffer.getByte(id));
        }
      }
      if (arg5.isSet == 1) {
        for (int id = arg5.start; id < arg5.end; id++) {
          out.buffer.setByte(out.end++, arg5.buffer.getByte(id));
        }
      }
      if (arg6.isSet == 1) {
        for (int id = arg6.start; id < arg6.end; id++) {
          out.buffer.setByte(out.end++, arg6.buffer.getByte(id));
        }
      }
      if (arg7.isSet == 1) {
        for (int id = arg7.start; id < arg7.end; id++) {
          out.buffer.setByte(out.end++, arg7.buffer.getByte(id));
        }
      }
      if (arg8.isSet == 1) {
        for (int id = arg8.start; id < arg8.end; id++) {
          out.buffer.setByte(out.end++, arg8.buffer.getByte(id));
        }
      }
      if (arg9.isSet == 1) {
        for (int id = arg9.start; id < arg9.end; id++) {
          out.buffer.setByte(out.end++, arg9.buffer.getByte(id));
        }
      }
      if (arg10.isSet == 1) {
        for (int id = arg10.start; id < arg10.end; id++) {
          out.buffer.setByte(out.end++, arg10.buffer.getByte(id));
        }
      }
    }
  }
}
