
//////////////////////////////////////////////////////////////////////////////////////////////////
//Functions for Extended Math Functions
//////////////////////////////////////////////////////////////////////////////////////////////////


package com.dremio.exec.expr.fn.impl;

import com.dremio.common.types.TypeProtos;
import com.dremio.common.types.Types;
import com.dremio.common.types.TypeProtos.MinorType;
import com.dremio.exec.expr.SimpleFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.FunctionScope;
import com.dremio.exec.expr.annotations.FunctionTemplate.FunctionScope;
import com.dremio.exec.expr.annotations.FunctionTemplate.NullHandling;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.annotations.Workspace;
import com.dremio.exec.expr.fn.impl.StringFunctions;
import org.apache.arrow.vector.holders.*;
/*
 * This class is automatically generated from MathFunc.tdd using FreeMarker.
 */

@SuppressWarnings("unused")

public class ExtendedMathFunctions{
  static final org.slf4j.Logger logger = org.slf4j.LoggerFactory.getLogger(ExtendedMathFunctions.class);

  private ExtendedMathFunctions(){}

//////////////////////////////////////////////////////////////////////////////////////////////////
//Unary Math functions with 1 parameter.
//////////////////////////////////////////////////////////////////////////////////////////////////



@FunctionTemplate(name = "cbrt", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class CbrtInt implements SimpleFunction {

  @Param IntHolder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.cbrt(in.value);
  }
}


@FunctionTemplate(name = "cbrt", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class CbrtBigInt implements SimpleFunction {

  @Param BigIntHolder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.cbrt(in.value);
  }
}


@FunctionTemplate(name = "cbrt", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class CbrtFloat4 implements SimpleFunction {

  @Param Float4Holder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.cbrt(in.value);
  }
}


@FunctionTemplate(name = "cbrt", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class CbrtFloat8 implements SimpleFunction {

  @Param Float8Holder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.cbrt(in.value);
  }
}



@FunctionTemplate(name = "exp", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class ExpInt implements SimpleFunction {

  @Param IntHolder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.exp(in.value);
  }
}


@FunctionTemplate(name = "exp", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class ExpBigInt implements SimpleFunction {

  @Param BigIntHolder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.exp(in.value);
  }
}


@FunctionTemplate(name = "exp", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class ExpFloat4 implements SimpleFunction {

  @Param Float4Holder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.exp(in.value);
  }
}


@FunctionTemplate(name = "exp", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class ExpFloat8 implements SimpleFunction {

  @Param Float8Holder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.exp(in.value);
  }
}



@FunctionTemplate(name = "log", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class LogInt implements SimpleFunction {

  @Param IntHolder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.log(in.value);
  }
}


@FunctionTemplate(name = "log", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class LogBigInt implements SimpleFunction {

  @Param BigIntHolder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.log(in.value);
  }
}


@FunctionTemplate(name = "log", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class LogFloat4 implements SimpleFunction {

  @Param Float4Holder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.log(in.value);
  }
}


@FunctionTemplate(name = "log", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class LogFloat8 implements SimpleFunction {

  @Param Float8Holder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.log(in.value);
  }
}



@FunctionTemplate(name = "log10", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class Log10Int implements SimpleFunction {

  @Param IntHolder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.log10(in.value);
  }
}


@FunctionTemplate(name = "log10", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class Log10BigInt implements SimpleFunction {

  @Param BigIntHolder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.log10(in.value);
  }
}


@FunctionTemplate(name = "log10", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class Log10Float4 implements SimpleFunction {

  @Param Float4Holder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.log10(in.value);
  }
}


@FunctionTemplate(name = "log10", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class Log10Float8 implements SimpleFunction {

  @Param Float8Holder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.log10(in.value);
  }
}



@FunctionTemplate(name = "degrees", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class DegreesInt implements SimpleFunction {

  @Param IntHolder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.toDegrees(in.value);
  }
}


@FunctionTemplate(name = "degrees", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class DegreesBigInt implements SimpleFunction {

  @Param BigIntHolder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.toDegrees(in.value);
  }
}


@FunctionTemplate(name = "degrees", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class DegreesFloat4 implements SimpleFunction {

  @Param Float4Holder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.toDegrees(in.value);
  }
}


@FunctionTemplate(name = "degrees", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class DegreesFloat8 implements SimpleFunction {

  @Param Float8Holder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.toDegrees(in.value);
  }
}



@FunctionTemplate(name = "radians", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class RadiansInt implements SimpleFunction {

  @Param IntHolder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.toRadians(in.value);
  }
}


@FunctionTemplate(name = "radians", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class RadiansBigInt implements SimpleFunction {

  @Param BigIntHolder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.toRadians(in.value);
  }
}


@FunctionTemplate(name = "radians", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class RadiansFloat4 implements SimpleFunction {

  @Param Float4Holder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.toRadians(in.value);
  }
}


@FunctionTemplate(name = "radians", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class RadiansFloat8 implements SimpleFunction {

  @Param Float8Holder in;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.toRadians(in.value);
  }
}



//////////////////////////////////////////////////////////////////////////////////////////////////
//Function to handle Log with base.
//////////////////////////////////////////////////////////////////////////////////////////////////

@FunctionTemplate(name = "log", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class LogBaseInt implements SimpleFunction {

  @Param IntHolder base;
  @Param IntHolder val;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.log(val.value)/ java.lang.Math.log(base.value);
  }
}

@FunctionTemplate(name = "log", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class LogBaseBigInt implements SimpleFunction {

  @Param BigIntHolder base;
  @Param BigIntHolder val;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.log(val.value)/ java.lang.Math.log(base.value);
  }
}

@FunctionTemplate(name = "log", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class LogBaseFloat4 implements SimpleFunction {

  @Param Float4Holder base;
  @Param Float4Holder val;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.log(val.value)/ java.lang.Math.log(base.value);
  }
}

@FunctionTemplate(name = "log", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public static class LogBaseFloat8 implements SimpleFunction {

  @Param Float8Holder base;
  @Param Float8Holder val;
  @Output Float8Holder out;

  public void setup() {
  }

  public void eval() {
	  out.value = java.lang.Math.log(val.value)/ java.lang.Math.log(base.value);
  }
}


}

//////////////////////////////////////////////////////////////////////////////////////////////////
//End of Extended Math Functions
//////////////////////////////////////////////////////////////////////////////////////////////////


