

package com.dremio.exec.expr.fn.impl;

import com.dremio.exec.expr.SimpleFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.NullHandling;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.fn.FunctionGenerationHelper;
import org.apache.arrow.memory.util.ByteFunctionHelpers;
import org.apache.arrow.vector.holders.*;
import javax.inject.Inject;
import org.apache.arrow.memory.ArrowBuf;

/**
 * generated from ComparisonFunctions.java Float8 Float8
 */
@SuppressWarnings("unused")
public class GCompareFloat8VsFloat8 {



  @FunctionTemplate(name = FunctionGenerationHelper.COMPARE_TO_NULLS_HIGH,
                    scope = FunctionTemplate.FunctionScope.SIMPLE,
                    nulls = NullHandling.INTERNAL)
  public static class GCompareNullableFloat8VsNullableFloat8NullHigh implements SimpleFunction {

    @Param NullableFloat8Holder left;
    @Param NullableFloat8Holder right;
    @Output NullableIntHolder out;

    public void setup() {}

    public void eval() {
      out.isSet = 1;
     outside:
      {

        if ( left.isSet == 0 ) {
          if ( right.isSet == 0 ) {
            out.value = 0;
            break outside;
          } else {
            out.value = 1;
            break outside;
          }
        } else if ( right.isSet == 0 ) {
          out.value = -1;
          break outside;
        }


      out.value = Double.compare(left.value, right.value);

      } // outside
    }
  }

  @FunctionTemplate(name = FunctionGenerationHelper.COMPARE_TO_NULLS_LOW,
                    scope = FunctionTemplate.FunctionScope.SIMPLE,
                    nulls = NullHandling.INTERNAL)
  public static class GCompareNullableFloat8VsNullableFloat8NullLow implements SimpleFunction {

    @Param NullableFloat8Holder left;
    @Param NullableFloat8Holder right;
    @Output NullableIntHolder out;

    public void setup() {}

    public void eval() {
      out.isSet = 1;
     outside:
      {

        if ( left.isSet == 0 ) {
          if ( right.isSet == 0 ) {
            out.value = 0;
            break outside;
          } else {
            out.value = -1;
            break outside;
          }
        } else if ( right.isSet == 0 ) {
          out.value = 1;
          break outside;
        }


      out.value = Double.compare(left.value, right.value);

      } // outside
    }
  }

  @FunctionTemplate(names = {"is_distinct_from", "is distinct from" },
                    scope = FunctionTemplate.FunctionScope.SIMPLE, nulls = NullHandling.INTERNAL)
  public static class GIsDistinctFromNullableFloat8VsNullableFloat8 implements SimpleFunction {
    @Param NullableFloat8Holder left;
    @Param NullableFloat8Holder right;
    @Output NullableBitHolder out;

    public void setup() {}

    public void eval() {
      outside:{
          
          out.isSet = 1;
        if(left.isSet==0){
          if(right.isSet==0){
            out.value=0;
            break outside;
          }else{
            out.value=1;
            break outside;
          }
        } else {
          if(right.isSet==0){
            out.value=1;
            break outside;
          }
        }

        out.value = left.value == right.value ? 0 : 1;
      }
    }
  }

  @FunctionTemplate(names = {"is_not_distinct_from", "is not distinct from" },
                    scope = FunctionTemplate.FunctionScope.SIMPLE, nulls = NullHandling.INTERNAL)
  public static class GIsNotDistinctFromNullableFloat8VsNullableFloat8 implements SimpleFunction {
    @Param NullableFloat8Holder left;
    @Param NullableFloat8Holder right;
    @Output NullableBitHolder out;

    public void setup() {}

    public void eval() {
      outside:{
          
          out.isSet = 1;
        if(left.isSet==0){
          if(right.isSet==0){
            out.value=1;
            break outside;
          }else{
            out.value=0;
            break outside;
          }
        } else {
          if(right.isSet==0){
            out.value=0;
            break outside;
          }
        }

        out.value = left.value == right.value ? 1 : 0;
      }
    }
  }

   @FunctionTemplate(names = {"less_than", "<"},
                    scope = FunctionTemplate.FunctionScope.SIMPLE,
                    nulls = NullHandling.NULL_IF_NULL)
  public static class LessThanFloat8VsFloat8 implements SimpleFunction {

      @Param Float8Holder left;
      @Param Float8Holder right;
      @Output NullableBitHolder out;

      public void setup() {}

      public void eval() {

          out.value = left.value < right.value ? 1 : 0;

      }
  }

  @FunctionTemplate(names = {"less_than_or_equal_to", "<="},
                    scope = FunctionTemplate.FunctionScope.SIMPLE,
                    nulls = NullHandling.NULL_IF_NULL)
  public static class LessThanEqFloat8VsFloat8 implements SimpleFunction {

      @Param Float8Holder left;
      @Param Float8Holder right;
      @Output NullableBitHolder out;

      public void setup() {}

      public void eval() {

          out.value = left.value <= right.value ? 1 : 0;

    }
  }

  @FunctionTemplate(names = {"greater_than", ">"},
                    scope = FunctionTemplate.FunctionScope.SIMPLE,
                    nulls = NullHandling.NULL_IF_NULL)
  public static class GreaterThanFloat8VsFloat8 implements SimpleFunction {

      @Param Float8Holder left;
      @Param Float8Holder right;
      @Output NullableBitHolder out;

      public void setup() {}

      public void eval() {

          out.value = left.value > right.value ? 1 : 0;

    }
  }

  @FunctionTemplate(names = {"greater_than_or_equal_to", ">="},
                    scope = FunctionTemplate.FunctionScope.SIMPLE,
                    nulls = NullHandling.NULL_IF_NULL)
  public static class GreaterThanEqFloat8VsFloat8 implements SimpleFunction {

      @Param Float8Holder left;
      @Param Float8Holder right;
      @Output NullableBitHolder out;

      public void setup() {}

      public void eval() {

          out.value = left.value >= right.value ? 1 : 0;

      }
  }

  @FunctionTemplate(names = {"equal", "==", "="},
                    scope = FunctionTemplate.FunctionScope.SIMPLE,
                    nulls = NullHandling.NULL_IF_NULL)
  public static class EqualsFloat8VsFloat8 implements SimpleFunction {

      @Param Float8Holder left;
      @Param Float8Holder right;
      @Output NullableBitHolder out;

      public void setup() {}

      public void eval() {

          out.value = left.value == right.value ? 1 : 0;

      }
  }

  @FunctionTemplate(names = {"not_equal", "<>", "!="},
                    scope = FunctionTemplate.FunctionScope.SIMPLE,
                    nulls = NullHandling.NULL_IF_NULL)
  public static class NotEqualsFloat8VsFloat8 implements SimpleFunction {

      @Param Float8Holder left;
      @Param Float8Holder right;
      @Output NullableBitHolder out;

      public void setup() {}

      public void eval() {

          out.value = left.value != right.value ? 1 : 0;

      }
  }

}


 



