

package com.dremio.exec.expr.fn.impl;

import com.dremio.exec.expr.SimpleFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.NullHandling;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.fn.FunctionGenerationHelper;
import org.apache.arrow.memory.util.ByteFunctionHelpers;
import org.apache.arrow.vector.holders.*;
import javax.inject.Inject;
import org.apache.arrow.memory.ArrowBuf;

/**
 * generated from ComparisonFunctions.java VarBinary VarChar
 */
@SuppressWarnings("unused")
public class GCompareVarBinaryVsVarChar {



  @FunctionTemplate(name = FunctionGenerationHelper.COMPARE_TO_NULLS_HIGH,
                    scope = FunctionTemplate.FunctionScope.SIMPLE,
                    nulls = NullHandling.INTERNAL)
  public static class GCompareNullableVarBinaryVsNullableVarCharNullHigh implements SimpleFunction {

    @Param NullableVarBinaryHolder left;
    @Param NullableVarCharHolder right;
    @Output NullableIntHolder out;

    public void setup() {}

    public void eval() {
      out.isSet = 1;
     outside:
      {

        if ( left.isSet == 0 ) {
          if ( right.isSet == 0 ) {
            out.value = 0;
            break outside;
          } else {
            out.value = 1;
            break outside;
          }
        } else if ( right.isSet == 0 ) {
          out.value = -1;
          break outside;
        }


      out.value = org.apache.arrow.memory.util.ByteFunctionHelpers.compare(
          left.buffer, left.start, left.end, right.buffer, right.start, right.end );

      } // outside
    }
  }

  @FunctionTemplate(name = FunctionGenerationHelper.COMPARE_TO_NULLS_LOW,
                    scope = FunctionTemplate.FunctionScope.SIMPLE,
                    nulls = NullHandling.INTERNAL)
  public static class GCompareNullableVarBinaryVsNullableVarCharNullLow implements SimpleFunction {

    @Param NullableVarBinaryHolder left;
    @Param NullableVarCharHolder right;
    @Output NullableIntHolder out;

    public void setup() {}

    public void eval() {
      out.isSet = 1;
     outside:
      {

        if ( left.isSet == 0 ) {
          if ( right.isSet == 0 ) {
            out.value = 0;
            break outside;
          } else {
            out.value = -1;
            break outside;
          }
        } else if ( right.isSet == 0 ) {
          out.value = 1;
          break outside;
        }


      out.value = org.apache.arrow.memory.util.ByteFunctionHelpers.compare(
          left.buffer, left.start, left.end, right.buffer, right.start, right.end );

      } // outside
    }
  }

  @FunctionTemplate(names = {"is_distinct_from", "is distinct from" },
                    scope = FunctionTemplate.FunctionScope.SIMPLE, nulls = NullHandling.INTERNAL)
  public static class GIsDistinctFromNullableVarBinaryVsNullableVarChar implements SimpleFunction {
    @Param NullableVarBinaryHolder left;
    @Param NullableVarCharHolder right;
    @Output NullableBitHolder out;

    public void setup() {}

    public void eval() {
      outside:{
          
          out.isSet = 1;
        if(left.isSet==0){
          if(right.isSet==0){
            out.value=0;
            break outside;
          }else{
            out.value=1;
            break outside;
          }
        } else {
          if(right.isSet==0){
            out.value=1;
            break outside;
          }
        }

        out.value = org.apache.arrow.memory.util.ByteFunctionHelpers.compare(
            left.buffer, left.start, left.end, right.buffer, right.start, right.end) == 0 ? 0 : 1;
      }
    }
  }

  @FunctionTemplate(names = {"is_not_distinct_from", "is not distinct from" },
                    scope = FunctionTemplate.FunctionScope.SIMPLE, nulls = NullHandling.INTERNAL)
  public static class GIsNotDistinctFromNullableVarBinaryVsNullableVarChar implements SimpleFunction {
    @Param NullableVarBinaryHolder left;
    @Param NullableVarCharHolder right;
    @Output NullableBitHolder out;

    public void setup() {}

    public void eval() {
      outside:{
          
          out.isSet = 1;
        if(left.isSet==0){
          if(right.isSet==0){
            out.value=1;
            break outside;
          }else{
            out.value=0;
            break outside;
          }
        } else {
          if(right.isSet==0){
            out.value=0;
            break outside;
          }
        }

        out.value = org.apache.arrow.memory.util.ByteFunctionHelpers.compare(
            left.buffer, left.start, left.end, right.buffer, right.start, right.end) == 0 ? 1 : 0;
      }
    }
  }

   @FunctionTemplate(names = {"less_than", "<"},
                    scope = FunctionTemplate.FunctionScope.SIMPLE,
                    nulls = NullHandling.NULL_IF_NULL)
  public static class LessThanVarBinaryVsVarChar implements SimpleFunction {

      @Param VarBinaryHolder left;
      @Param VarCharHolder right;
      @Output NullableBitHolder out;

      public void setup() {}

      public void eval() {

          int cmp;
     outside:
      {



      cmp = org.apache.arrow.memory.util.ByteFunctionHelpers.compare(
          left.buffer, left.start, left.end, right.buffer, right.start, right.end );

      } // outside
          out.value = cmp == -1 ? 1 : 0;

      }
  }

  @FunctionTemplate(names = {"less_than_or_equal_to", "<="},
                    scope = FunctionTemplate.FunctionScope.SIMPLE,
                    nulls = NullHandling.NULL_IF_NULL)
  public static class LessThanEqVarBinaryVsVarChar implements SimpleFunction {

      @Param VarBinaryHolder left;
      @Param VarCharHolder right;
      @Output NullableBitHolder out;

      public void setup() {}

      public void eval() {

          int cmp;
     outside:
      {



      cmp = org.apache.arrow.memory.util.ByteFunctionHelpers.compare(
          left.buffer, left.start, left.end, right.buffer, right.start, right.end );

      } // outside
          out.value = cmp < 1 ? 1 : 0;

    }
  }

  @FunctionTemplate(names = {"greater_than", ">"},
                    scope = FunctionTemplate.FunctionScope.SIMPLE,
                    nulls = NullHandling.NULL_IF_NULL)
  public static class GreaterThanVarBinaryVsVarChar implements SimpleFunction {

      @Param VarBinaryHolder left;
      @Param VarCharHolder right;
      @Output NullableBitHolder out;

      public void setup() {}

      public void eval() {

          int cmp;
     outside:
      {



      cmp = org.apache.arrow.memory.util.ByteFunctionHelpers.compare(
          left.buffer, left.start, left.end, right.buffer, right.start, right.end );

      } // outside
          out.value = cmp == 1 ? 1 : 0;

    }
  }

  @FunctionTemplate(names = {"greater_than_or_equal_to", ">="},
                    scope = FunctionTemplate.FunctionScope.SIMPLE,
                    nulls = NullHandling.NULL_IF_NULL)
  public static class GreaterThanEqVarBinaryVsVarChar implements SimpleFunction {

      @Param VarBinaryHolder left;
      @Param VarCharHolder right;
      @Output NullableBitHolder out;

      public void setup() {}

      public void eval() {

          int cmp;
     outside:
      {



      cmp = org.apache.arrow.memory.util.ByteFunctionHelpers.compare(
          left.buffer, left.start, left.end, right.buffer, right.start, right.end );

      } // outside
          out.value = cmp > -1 ? 1 : 0;

      }
  }

  @FunctionTemplate(names = {"equal", "==", "="},
                    scope = FunctionTemplate.FunctionScope.SIMPLE,
                    nulls = NullHandling.NULL_IF_NULL)
  public static class EqualsVarBinaryVsVarChar implements SimpleFunction {

      @Param VarBinaryHolder left;
      @Param VarCharHolder right;
      @Output NullableBitHolder out;

      public void setup() {}

      public void eval() {

          out.value = org.apache.arrow.memory.util.ByteFunctionHelpers.equal(
              left.buffer, left.start, left.end, right.buffer, right.start, right.end);

      }
  }

  @FunctionTemplate(names = {"not_equal", "<>", "!="},
                    scope = FunctionTemplate.FunctionScope.SIMPLE,
                    nulls = NullHandling.NULL_IF_NULL)
  public static class NotEqualsVarBinaryVsVarChar implements SimpleFunction {

      @Param VarBinaryHolder left;
      @Param VarCharHolder right;
      @Output NullableBitHolder out;

      public void setup() {}

      public void eval() {

          int cmp;
     outside:
      {



      cmp = org.apache.arrow.memory.util.ByteFunctionHelpers.compare(
          left.buffer, left.start, left.end, right.buffer, right.start, right.end );

      } // outside
          out.value = cmp == 0 ? 0 : 1;

      }
  }

}



