

/*
 * This class is automatically generated from AddTypes.tdd using FreeMarker.
 */


package com.dremio.exec.expr.fn.impl;


import com.dremio.common.types.TypeProtos;
import com.dremio.common.types.Types;
import com.dremio.common.types.TypeProtos.MinorType;
import com.dremio.exec.expr.SimpleFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.FunctionScope;
import com.dremio.exec.expr.annotations.FunctionTemplate.FunctionScope;
import com.dremio.exec.expr.annotations.FunctionTemplate.NullHandling;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.annotations.Workspace;
import com.dremio.exec.expr.fn.impl.StringFunctions;
import org.apache.arrow.vector.holders.*;

@SuppressWarnings("unused")

public class GMathFunctions{
  static final org.slf4j.Logger logger = org.slf4j.LoggerFactory.getLogger(GMathFunctions.class);
  
  private GMathFunctions(){}



  @FunctionTemplate(name = "abs", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class AbsInt implements SimpleFunction {

    @Param IntHolder in;
    @Output IntHolder out;

    public void setup() {
    }

    public void eval() {

      out.value = (int) java.lang.Math.abs(in.value);
    }
  }
  

  @FunctionTemplate(name = "abs", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class AbsBigInt implements SimpleFunction {

    @Param BigIntHolder in;
    @Output BigIntHolder out;

    public void setup() {
    }

    public void eval() {

      out.value = (long) java.lang.Math.abs(in.value);
    }
  }
  

  @FunctionTemplate(name = "abs", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class AbsFloat4 implements SimpleFunction {

    @Param Float4Holder in;
    @Output Float4Holder out;

    public void setup() {
    }

    public void eval() {

      out.value = (float) java.lang.Math.abs(in.value);
    }
  }
  

  @FunctionTemplate(name = "abs", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class AbsFloat8 implements SimpleFunction {

    @Param Float8Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {

      out.value = (double) java.lang.Math.abs(in.value);
    }
  }
  


  @FunctionTemplate(name = "ceil", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class CeilInt implements SimpleFunction {

    @Param IntHolder in;
    @Output IntHolder out;

    public void setup() {
    }

    public void eval() {

      out.value = (int) java.lang.Math.ceil(in.value);
    }
  }
  

  @FunctionTemplate(name = "ceil", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class CeilBigInt implements SimpleFunction {

    @Param BigIntHolder in;
    @Output BigIntHolder out;

    public void setup() {
    }

    public void eval() {

      out.value = (long) java.lang.Math.ceil(in.value);
    }
  }
  

  @FunctionTemplate(name = "ceil", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class CeilFloat4 implements SimpleFunction {

    @Param Float4Holder in;
    @Output Float4Holder out;

    public void setup() {
    }

    public void eval() {

      out.value = (float) java.lang.Math.ceil(in.value);
    }
  }
  

  @FunctionTemplate(name = "ceil", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class CeilFloat8 implements SimpleFunction {

    @Param Float8Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {

      out.value = (double) java.lang.Math.ceil(in.value);
    }
  }
  


  @FunctionTemplate(name = "floor", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class FloorInt implements SimpleFunction {

    @Param IntHolder in;
    @Output IntHolder out;

    public void setup() {
    }

    public void eval() {

      out.value = (int) java.lang.Math.floor(in.value);
    }
  }
  

  @FunctionTemplate(name = "floor", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class FloorBigInt implements SimpleFunction {

    @Param BigIntHolder in;
    @Output BigIntHolder out;

    public void setup() {
    }

    public void eval() {

      out.value = (long) java.lang.Math.floor(in.value);
    }
  }
  

  @FunctionTemplate(name = "floor", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class FloorFloat4 implements SimpleFunction {

    @Param Float4Holder in;
    @Output Float4Holder out;

    public void setup() {
    }

    public void eval() {

      out.value = (float) java.lang.Math.floor(in.value);
    }
  }
  

  @FunctionTemplate(name = "floor", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class FloorFloat8 implements SimpleFunction {

    @Param Float8Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {

      out.value = (double) java.lang.Math.floor(in.value);
    }
  }
  


  @FunctionTemplate(name = "sqrt", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class SqrtInt implements SimpleFunction {

    @Param IntHolder in;
    @Output IntHolder out;

    public void setup() {
    }

    public void eval() {

      out.value = (int) java.lang.Math.sqrt(in.value);
    }
  }
  

  @FunctionTemplate(name = "sqrt", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class SqrtBigInt implements SimpleFunction {

    @Param BigIntHolder in;
    @Output BigIntHolder out;

    public void setup() {
    }

    public void eval() {

      out.value = (long) java.lang.Math.sqrt(in.value);
    }
  }
  

  @FunctionTemplate(name = "sqrt", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class SqrtFloat4 implements SimpleFunction {

    @Param Float4Holder in;
    @Output Float4Holder out;

    public void setup() {
    }

    public void eval() {

      out.value = (float) java.lang.Math.sqrt(in.value);
    }
  }
  

  @FunctionTemplate(name = "sqrt", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class SqrtFloat8 implements SimpleFunction {

    @Param Float8Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {

      out.value = (double) java.lang.Math.sqrt(in.value);
    }
  }
  


  @FunctionTemplate(name = "truncate", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class TruncateInt implements SimpleFunction {

    @Param IntHolder in;
    @Output IntHolder out;

    public void setup() {
    }

    public void eval() {

      out.value = (int) (in.value);
    }
  }
  

  @FunctionTemplate(name = "truncate", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class TruncateBigInt implements SimpleFunction {

    @Param BigIntHolder in;
    @Output BigIntHolder out;

    public void setup() {
    }

    public void eval() {

      out.value = (long) (in.value);
    }
  }
  

  @FunctionTemplate(name = "truncate", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class TruncateFloat4 implements SimpleFunction {

    @Param Float4Holder in;
    @Output Float4Holder out;

    public void setup() {
    }

    public void eval() {

      java.math.BigDecimal bd = java.math.BigDecimal.valueOf(in.value).setScale(0, java.math.BigDecimal.ROUND_DOWN);
      out.value = bd.floatValue();

    }
  }
  

  @FunctionTemplate(name = "truncate", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class TruncateFloat8 implements SimpleFunction {

    @Param Float8Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {

      java.math.BigDecimal bd = java.math.BigDecimal.valueOf(in.value).setScale(0, java.math.BigDecimal.ROUND_DOWN);
      out.value = bd.doubleValue();

    }
  }
  


  @FunctionTemplate(name = "trunc", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class TruncInt implements SimpleFunction {

    @Param IntHolder in;
    @Output IntHolder out;

    public void setup() {
    }

    public void eval() {

      out.value = (int) (in.value);
    }
  }
  

  @FunctionTemplate(name = "trunc", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class TruncBigInt implements SimpleFunction {

    @Param BigIntHolder in;
    @Output BigIntHolder out;

    public void setup() {
    }

    public void eval() {

      out.value = (long) (in.value);
    }
  }
  

  @FunctionTemplate(name = "trunc", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class TruncFloat4 implements SimpleFunction {

    @Param Float4Holder in;
    @Output Float4Holder out;

    public void setup() {
    }

    public void eval() {

      java.math.BigDecimal bd = java.math.BigDecimal.valueOf(in.value).setScale(0, java.math.BigDecimal.ROUND_DOWN);
      out.value = bd.floatValue();

    }
  }
  

  @FunctionTemplate(name = "trunc", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class TruncFloat8 implements SimpleFunction {

    @Param Float8Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {

      java.math.BigDecimal bd = java.math.BigDecimal.valueOf(in.value).setScale(0, java.math.BigDecimal.ROUND_DOWN);
      out.value = bd.doubleValue();

    }
  }
  


  @FunctionTemplate(name = "sign", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class SignInt implements SimpleFunction {

    @Param IntHolder in;
    @Output IntHolder out;

    public void setup() {
    }

    public void eval() {

      out.value = (int) java.lang.Math.signum(in.value);
    }
  }
  

  @FunctionTemplate(name = "sign", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class SignBigInt implements SimpleFunction {

    @Param BigIntHolder in;
    @Output BigIntHolder out;

    public void setup() {
    }

    public void eval() {

      out.value = (int) java.lang.Math.signum(in.value);
    }
  }
  

  @FunctionTemplate(name = "sign", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class SignFloat4 implements SimpleFunction {

    @Param Float4Holder in;
    @Output Float4Holder out;

    public void setup() {
    }

    public void eval() {

      out.value = (int) java.lang.Math.signum(in.value);
    }
  }
  

  @FunctionTemplate(name = "sign", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class SignFloat8 implements SimpleFunction {

    @Param Float8Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {

      out.value = (int) java.lang.Math.signum(in.value);
    }
  }
  


  //////////////////////////////////////////////////////////////////////////////////////////////////
  //Math functions which take two arguments (of same type). 
  //////////////////////////////////////////////////////////////////////////////////////////////////
  

  @FunctionTemplate(name = "div", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class DivInt implements SimpleFunction {

    @Param IntHolder input1;
    @Param IntHolder input2;
    @Output IntHolder out;

    public void setup() {
    }

    public void eval() {
    out.value = (int) ( input1.value  /  input2.value);
    }
  }

  @FunctionTemplate(name = "div", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class DivBigInt implements SimpleFunction {

    @Param BigIntHolder input1;
    @Param BigIntHolder input2;
    @Output BigIntHolder out;

    public void setup() {
    }

    public void eval() {
    out.value = (long) ( input1.value  /  input2.value);
    }
  }

  @FunctionTemplate(name = "div", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class DivFloat4 implements SimpleFunction {

    @Param Float4Holder input1;
    @Param Float4Holder input2;
    @Output Float4Holder out;

    public void setup() {
    }

    public void eval() {
    java.math.BigDecimal bdOut = java.math.BigDecimal.valueOf(input1.value  /  input2.value).setScale(0, java.math.BigDecimal.ROUND_DOWN);
    out.value = bdOut.floatValue();
    }
  }

  @FunctionTemplate(name = "div", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class DivFloat8 implements SimpleFunction {

    @Param Float8Holder input1;
    @Param Float8Holder input2;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
    java.math.BigDecimal bdOut = java.math.BigDecimal.valueOf(input1.value  /  input2.value).setScale(0, java.math.BigDecimal.ROUND_DOWN);
    out.value = bdOut.doubleValue();
    }
  }

  @FunctionTemplate(name = "lshift", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class LeftShiftInt implements SimpleFunction {

    @Param IntHolder input1;
    @Param IntHolder input2;
    @Output IntHolder out;

    public void setup() {
    }

    public void eval() {
    out.value =(int) ( input1.value  <<  input2.value);
    }
  }

  @FunctionTemplate(name = "lshift", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class LeftShiftBigInt implements SimpleFunction {

    @Param BigIntHolder input1;
    @Param BigIntHolder input2;
    @Output BigIntHolder out;

    public void setup() {
    }

    public void eval() {
    out.value =(long) ( input1.value  <<  input2.value);
    }
  }

  @FunctionTemplate(name = "rshift", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class RightShiftInt implements SimpleFunction {

    @Param IntHolder input1;
    @Param IntHolder input2;
    @Output IntHolder out;

    public void setup() {
    }

    public void eval() {
    out.value =(int) ( input1.value  >>  input2.value);
    }
  }

  @FunctionTemplate(name = "rshift", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class RightShiftBigInt implements SimpleFunction {

    @Param BigIntHolder input1;
    @Param BigIntHolder input2;
    @Output BigIntHolder out;

    public void setup() {
    }

    public void eval() {
    out.value =(long) ( input1.value  >>  input2.value);
    }
  }


  @FunctionTemplate(name = "truncate", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class Truncate2Int implements SimpleFunction {

    @Param IntHolder input1;
    @Param IntHolder input2;
    @Output IntHolder out;

    public void setup() {
    }

    public void eval() {
      java.math.BigDecimal temp = java.math.BigDecimal.valueOf(input1.value);
        out.value = (int) temp.setScale(input2.value, java.math.RoundingMode.DOWN).longValue();
    }
  }

  @FunctionTemplate(name = "truncate", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class Truncate2BigInt implements SimpleFunction {

    @Param BigIntHolder input1;
    @Param IntHolder input2;
    @Output BigIntHolder out;

    public void setup() {
    }

    public void eval() {
      java.math.BigDecimal temp = java.math.BigDecimal.valueOf(input1.value);
        out.value = (long) temp.setScale(input2.value, java.math.RoundingMode.DOWN).longValue();
    }
  }

  @FunctionTemplate(name = "truncate", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class Truncate2Float4 implements SimpleFunction {

    @Param Float4Holder input1;
    @Param IntHolder input2;
    @Output Float4Holder out;

    public void setup() {
    }

    public void eval() {
      java.math.BigDecimal temp = java.math.BigDecimal.valueOf(input1.value);
      out.value = (float) temp.setScale(input2.value, java.math.RoundingMode.DOWN).doubleValue();
    }
  }

  @FunctionTemplate(name = "truncate", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class Truncate2Float8 implements SimpleFunction {

    @Param Float8Holder input1;
    @Param IntHolder input2;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      java.math.BigDecimal temp = java.math.BigDecimal.valueOf(input1.value);
      out.value = (double) temp.setScale(input2.value, java.math.RoundingMode.DOWN).doubleValue();
    }
  }

  @FunctionTemplate(name = "trunc", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class Trunc2Int implements SimpleFunction {

    @Param IntHolder input1;
    @Param IntHolder input2;
    @Output IntHolder out;

    public void setup() {
    }

    public void eval() {
      java.math.BigDecimal temp = java.math.BigDecimal.valueOf(input1.value);
        out.value = (int) temp.setScale(input2.value, java.math.RoundingMode.DOWN).longValue();
    }
  }

  @FunctionTemplate(name = "trunc", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class Trunc2BigInt implements SimpleFunction {

    @Param BigIntHolder input1;
    @Param IntHolder input2;
    @Output BigIntHolder out;

    public void setup() {
    }

    public void eval() {
      java.math.BigDecimal temp = java.math.BigDecimal.valueOf(input1.value);
        out.value = (long) temp.setScale(input2.value, java.math.RoundingMode.DOWN).longValue();
    }
  }

  @FunctionTemplate(name = "trunc", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class Trunc2Float4 implements SimpleFunction {

    @Param Float4Holder input1;
    @Param IntHolder input2;
    @Output Float4Holder out;

    public void setup() {
    }

    public void eval() {
      java.math.BigDecimal temp = java.math.BigDecimal.valueOf(input1.value);
      out.value = (float) temp.setScale(input2.value, java.math.RoundingMode.DOWN).doubleValue();
    }
  }

  @FunctionTemplate(name = "trunc", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class Trunc2Float8 implements SimpleFunction {

    @Param Float8Holder input1;
    @Param IntHolder input2;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      java.math.BigDecimal temp = java.math.BigDecimal.valueOf(input1.value);
      out.value = (double) temp.setScale(input2.value, java.math.RoundingMode.DOWN).doubleValue();
    }
  }

  @FunctionTemplate(name = "round", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class RounddInt implements SimpleFunction {

    @Param IntHolder input1;
    @Param IntHolder input2;
    @Output IntHolder out;

    public void setup() {
    }

    public void eval() {
      java.math.BigDecimal temp = java.math.BigDecimal.valueOf(input1.value);
        out.value = (int) temp.setScale(input2.value, java.math.RoundingMode.HALF_UP).longValue();
    }
  }

  @FunctionTemplate(name = "round", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class RounddBigInt implements SimpleFunction {

    @Param BigIntHolder input1;
    @Param IntHolder input2;
    @Output BigIntHolder out;

    public void setup() {
    }

    public void eval() {
      java.math.BigDecimal temp = java.math.BigDecimal.valueOf(input1.value);
        out.value = (long) temp.setScale(input2.value, java.math.RoundingMode.HALF_UP).longValue();
    }
  }

  @FunctionTemplate(name = "round", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class RounddFloat4 implements SimpleFunction {

    @Param Float4Holder input1;
    @Param IntHolder input2;
    @Output Float4Holder out;

    public void setup() {
    }

    public void eval() {
      java.math.BigDecimal temp = java.math.BigDecimal.valueOf(input1.value);
      out.value = (float) temp.setScale(input2.value, java.math.RoundingMode.HALF_UP).doubleValue();
    }
  }

  @FunctionTemplate(name = "round", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class RounddFloat8 implements SimpleFunction {

    @Param Float8Holder input1;
    @Param IntHolder input2;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      java.math.BigDecimal temp = java.math.BigDecimal.valueOf(input1.value);
      out.value = (double) temp.setScale(input2.value, java.math.RoundingMode.HALF_UP).doubleValue();
    }
  }
}



//////////////////////////////////////////////////////////////////////////////////////////////////
//End of GMath Functions
//////////////////////////////////////////////////////////////////////////////////////////////////




