
package com.dremio.exec.expr.fn.impl;

import com.dremio.exec.expr.SimpleFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.NullHandling;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.annotations.Workspace;
import org.apache.arrow.vector.holders.*;
import javax.inject.Inject;
import org.apache.arrow.memory.ArrowBuf;

/**
 * generated from NewPartitionFunctions.java 
 */
public class GNewPartitionNumberFunctions {


 

 
 

 

 
 
 


 

 
 
 


 

 
 
 



@SuppressWarnings("unused")
@FunctionTemplate(name = "newPartitionNumber", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
public static class NewPartitionNumberIntNullable implements SimpleFunction{

  @Param NullableIntHolder in;
  @Workspace NullableIntHolder previous;
  @Workspace int partitionNumber;
  @Output NullableIntHolder out;

  public void setup() {
    partitionNumber = -1;
  }


  public void eval() {
    if (partitionNumber != -1) {
      if (in.isSet == 0 && previous.isSet == 0) {
        out.value = partitionNumber;
      } else if (in.value == previous.value) {
        out.value = partitionNumber;
      } else {
        previous.value = in.value;
        previous.isSet = in.isSet;
        partitionNumber = partitionNumber + 1;
        out.value = partitionNumber;
      }
    } else {
      previous.value = in.value;
      previous.isSet = in.isSet;
      out.value = 1;
      partitionNumber = 0;
    }
    
    out.isSet = 1;
  }
}
 

 

 
 

 

 
 


@SuppressWarnings("unused")
@FunctionTemplate(name = "newPartitionNumber", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
public static class NewPartitionNumberFloat4Nullable implements SimpleFunction{

  @Param NullableFloat4Holder in;
  @Workspace NullableFloat4Holder previous;
  @Workspace int partitionNumber;
  @Output NullableIntHolder out;

  public void setup() {
    partitionNumber = -1;
  }


  public void eval() {
    if (partitionNumber != -1) {
      if (in.isSet == 0 && previous.isSet == 0) {
        out.value = partitionNumber;
      } else if (in.value == previous.value) {
        out.value = partitionNumber;
      } else {
        previous.value = in.value;
        previous.isSet = in.isSet;
        partitionNumber = partitionNumber + 1;
        out.value = partitionNumber;
      }
    } else {
      previous.value = in.value;
      previous.isSet = in.isSet;
      out.value = 1;
      partitionNumber = 0;
    }
    
    out.isSet = 1;
  }
}
 

 

 
 
 


 

 

 
 
 


@SuppressWarnings("unused")
@FunctionTemplate(name = "newPartitionNumber", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
public static class NewPartitionNumberTimeMilliNullable implements SimpleFunction{

  @Param NullableTimeMilliHolder in;
  @Workspace NullableTimeMilliHolder previous;
  @Workspace int partitionNumber;
  @Output NullableIntHolder out;

  public void setup() {
    partitionNumber = -1;
  }


  public void eval() {
    if (partitionNumber != -1) {
      if (in.isSet == 0 && previous.isSet == 0) {
        out.value = partitionNumber;
      } else if (in.value == previous.value) {
        out.value = partitionNumber;
      } else {
        previous.value = in.value;
        previous.isSet = in.isSet;
        partitionNumber = partitionNumber + 1;
        out.value = partitionNumber;
      }
    } else {
      previous.value = in.value;
      previous.isSet = in.isSet;
      out.value = 1;
      partitionNumber = 0;
    }
    
    out.isSet = 1;
  }
}
 

 

 
 
 



@SuppressWarnings("unused")
@FunctionTemplate(name = "newPartitionNumber", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
public static class NewPartitionNumberBigIntNullable implements SimpleFunction{

  @Param NullableBigIntHolder in;
  @Workspace NullableBigIntHolder previous;
  @Workspace int partitionNumber;
  @Output NullableIntHolder out;

  public void setup() {
    partitionNumber = -1;
  }


  public void eval() {
    if (partitionNumber != -1) {
      if (in.isSet == 0 && previous.isSet == 0) {
        out.value = partitionNumber;
      } else if (in.value == previous.value) {
        out.value = partitionNumber;
      } else {
        previous.value = in.value;
        previous.isSet = in.isSet;
        partitionNumber = partitionNumber + 1;
        out.value = partitionNumber;
      }
    } else {
      previous.value = in.value;
      previous.isSet = in.isSet;
      out.value = 1;
      partitionNumber = 0;
    }
    
    out.isSet = 1;
  }
}
 

 

 
 

 

 
 


@SuppressWarnings("unused")
@FunctionTemplate(name = "newPartitionNumber", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
public static class NewPartitionNumberFloat8Nullable implements SimpleFunction{

  @Param NullableFloat8Holder in;
  @Workspace NullableFloat8Holder previous;
  @Workspace int partitionNumber;
  @Output NullableIntHolder out;

  public void setup() {
    partitionNumber = -1;
  }


  public void eval() {
    if (partitionNumber != -1) {
      if (in.isSet == 0 && previous.isSet == 0) {
        out.value = partitionNumber;
      } else if (in.value == previous.value) {
        out.value = partitionNumber;
      } else {
        previous.value = in.value;
        previous.isSet = in.isSet;
        partitionNumber = partitionNumber + 1;
        out.value = partitionNumber;
      }
    } else {
      previous.value = in.value;
      previous.isSet = in.isSet;
      out.value = 1;
      partitionNumber = 0;
    }
    
    out.isSet = 1;
  }
}
 

 

 
 


@SuppressWarnings("unused")
@FunctionTemplate(name = "newPartitionNumber", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
public static class NewPartitionNumberDateMilliNullable implements SimpleFunction{

  @Param NullableDateMilliHolder in;
  @Workspace NullableDateMilliHolder previous;
  @Workspace int partitionNumber;
  @Output NullableIntHolder out;

  public void setup() {
    partitionNumber = -1;
  }


  public void eval() {
    if (partitionNumber != -1) {
      if (in.isSet == 0 && previous.isSet == 0) {
        out.value = partitionNumber;
      } else if (in.value == previous.value) {
        out.value = partitionNumber;
      } else {
        previous.value = in.value;
        previous.isSet = in.isSet;
        partitionNumber = partitionNumber + 1;
        out.value = partitionNumber;
      }
    } else {
      previous.value = in.value;
      previous.isSet = in.isSet;
      out.value = 1;
      partitionNumber = 0;
    }
    
    out.isSet = 1;
  }
}
 

 

 
 
 
 


@SuppressWarnings("unused")
@FunctionTemplate(name = "newPartitionNumber", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
public static class NewPartitionNumberTimeStampMilliNullable implements SimpleFunction{

  @Param NullableTimeStampMilliHolder in;
  @Workspace NullableTimeStampMilliHolder previous;
  @Workspace int partitionNumber;
  @Output NullableIntHolder out;

  public void setup() {
    partitionNumber = -1;
  }


  public void eval() {
    if (partitionNumber != -1) {
      if (in.isSet == 0 && previous.isSet == 0) {
        out.value = partitionNumber;
      } else if (in.value == previous.value) {
        out.value = partitionNumber;
      } else {
        previous.value = in.value;
        previous.isSet = in.isSet;
        partitionNumber = partitionNumber + 1;
        out.value = partitionNumber;
      }
    } else {
      previous.value = in.value;
      previous.isSet = in.isSet;
      out.value = 1;
      partitionNumber = 0;
    }
    
    out.isSet = 1;
  }
}
 

 

 
 
 
 
 
 
 
 
 
 
 



 

 

 
 
 



 

 

 
 
 

 
 



 

 

 
 
 



 

 

 
 
 
 
 



@SuppressWarnings("unused")
@FunctionTemplate(name = "newPartitionNumber", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
public static class NewPartitionNumberBitNullable implements SimpleFunction{

  @Param NullableBitHolder in;
  @Workspace NullableBitHolder previous;
  @Workspace int partitionNumber;
  @Output NullableIntHolder out;

  public void setup() {
    partitionNumber = -1;
  }


  public void eval() {
    if (partitionNumber != -1) {
      if (in.isSet == 0 && previous.isSet == 0) {
        out.value = partitionNumber;
      } else if (in.value == previous.value) {
        out.value = partitionNumber;
      } else {
        previous.value = in.value;
        previous.isSet = in.isSet;
        partitionNumber = partitionNumber + 1;
        out.value = partitionNumber;
      }
    } else {
      previous.value = in.value;
      previous.isSet = in.isSet;
      out.value = 1;
      partitionNumber = 0;
    }
    
    out.isSet = 1;
  }
}
 

 

 
 
 
}
