
package com.dremio.exec.expr.fn.impl;

import com.dremio.exec.expr.SimpleFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.NullHandling;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.annotations.Workspace;
import org.apache.arrow.vector.holders.*;
import javax.inject.Inject;
import org.apache.arrow.memory.ArrowBuf;

/**
 * generated from NewValueFunctions.java 
 */
public class GNewValueFunctions {

 
 
 
 
 
 
 

 
 
 
 

 
 
 
 


@SuppressWarnings("unused")
@FunctionTemplate(name = "newPartitionValue", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
public static class NewValueIntNullable implements SimpleFunction{

  @Param NullableIntHolder in;
  @Workspace NullableIntHolder previous;
  @Workspace Boolean initialized;
  @Output NullableBitHolder out;

  public void setup() {
    initialized = false;
  }

  public void eval() {
    if (initialized && // it's not the first value
      in.isSet == previous.isSet && // nullability didn't change
      (in.isSet == 0 || in.value == previous.value)) { // it's either a null partition or the value didn't change
      out.value = 0;
    } else { // start a new partition
      previous.value = in.value;
      previous.isSet = in.isSet;
      out.value = 1;
      initialized = true;
    }
    
    out.isSet = 1;
  }
}
 

 
 
 
 
 
 

@SuppressWarnings("unused")
@FunctionTemplate(name = "newPartitionValue", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
public static class NewValueFloat4Nullable implements SimpleFunction{

  @Param NullableFloat4Holder in;
  @Workspace NullableFloat4Holder previous;
  @Workspace Boolean initialized;
  @Output NullableBitHolder out;

  public void setup() {
    initialized = false;
  }

  public void eval() {
    if (initialized && // it's not the first value
      in.isSet == previous.isSet && // nullability didn't change
      (in.isSet == 0 || in.value == previous.value)) { // it's either a null partition or the value didn't change
      out.value = 0;
    } else { // start a new partition
      previous.value = in.value;
      previous.isSet = in.isSet;
      out.value = 1;
      initialized = true;
    }
    
    out.isSet = 1;
  }
}
 

 
 
 
 

 

 
 
 
 

@SuppressWarnings("unused")
@FunctionTemplate(name = "newPartitionValue", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
public static class NewValueTimeMilliNullable implements SimpleFunction{

  @Param NullableTimeMilliHolder in;
  @Workspace NullableTimeMilliHolder previous;
  @Workspace Boolean initialized;
  @Output NullableBitHolder out;

  public void setup() {
    initialized = false;
  }

  public void eval() {
    if (initialized && // it's not the first value
      in.isSet == previous.isSet && // nullability didn't change
      (in.isSet == 0 || in.value == previous.value)) { // it's either a null partition or the value didn't change
      out.value = 0;
    } else { // start a new partition
      previous.value = in.value;
      previous.isSet = in.isSet;
      out.value = 1;
      initialized = true;
    }
    
    out.isSet = 1;
  }
}
 

 
 
 
 


@SuppressWarnings("unused")
@FunctionTemplate(name = "newPartitionValue", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
public static class NewValueBigIntNullable implements SimpleFunction{

  @Param NullableBigIntHolder in;
  @Workspace NullableBigIntHolder previous;
  @Workspace Boolean initialized;
  @Output NullableBitHolder out;

  public void setup() {
    initialized = false;
  }

  public void eval() {
    if (initialized && // it's not the first value
      in.isSet == previous.isSet && // nullability didn't change
      (in.isSet == 0 || in.value == previous.value)) { // it's either a null partition or the value didn't change
      out.value = 0;
    } else { // start a new partition
      previous.value = in.value;
      previous.isSet = in.isSet;
      out.value = 1;
      initialized = true;
    }
    
    out.isSet = 1;
  }
}
 

 
 
 
 
 
 

@SuppressWarnings("unused")
@FunctionTemplate(name = "newPartitionValue", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
public static class NewValueFloat8Nullable implements SimpleFunction{

  @Param NullableFloat8Holder in;
  @Workspace NullableFloat8Holder previous;
  @Workspace Boolean initialized;
  @Output NullableBitHolder out;

  public void setup() {
    initialized = false;
  }

  public void eval() {
    if (initialized && // it's not the first value
      in.isSet == previous.isSet && // nullability didn't change
      (in.isSet == 0 || in.value == previous.value)) { // it's either a null partition or the value didn't change
      out.value = 0;
    } else { // start a new partition
      previous.value = in.value;
      previous.isSet = in.isSet;
      out.value = 1;
      initialized = true;
    }
    
    out.isSet = 1;
  }
}
 

 
 
 

@SuppressWarnings("unused")
@FunctionTemplate(name = "newPartitionValue", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
public static class NewValueDateMilliNullable implements SimpleFunction{

  @Param NullableDateMilliHolder in;
  @Workspace NullableDateMilliHolder previous;
  @Workspace Boolean initialized;
  @Output NullableBitHolder out;

  public void setup() {
    initialized = false;
  }

  public void eval() {
    if (initialized && // it's not the first value
      in.isSet == previous.isSet && // nullability didn't change
      (in.isSet == 0 || in.value == previous.value)) { // it's either a null partition or the value didn't change
      out.value = 0;
    } else { // start a new partition
      previous.value = in.value;
      previous.isSet = in.isSet;
      out.value = 1;
      initialized = true;
    }
    
    out.isSet = 1;
  }
}
 

 
 
 
 
 

@SuppressWarnings("unused")
@FunctionTemplate(name = "newPartitionValue", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
public static class NewValueTimeStampMilliNullable implements SimpleFunction{

  @Param NullableTimeStampMilliHolder in;
  @Workspace NullableTimeStampMilliHolder previous;
  @Workspace Boolean initialized;
  @Output NullableBitHolder out;

  public void setup() {
    initialized = false;
  }

  public void eval() {
    if (initialized && // it's not the first value
      in.isSet == previous.isSet && // nullability didn't change
      (in.isSet == 0 || in.value == previous.value)) { // it's either a null partition or the value didn't change
      out.value = 0;
    } else { // start a new partition
      previous.value = in.value;
      previous.isSet = in.isSet;
      out.value = 1;
      initialized = true;
    }
    
    out.isSet = 1;
  }
}
 

 
 
 
 
 
 
 
 
 
 
 
 


 

 
 
 
 


 

 
 
 
 

 
 


 

 
 
 
 


 

 
 
 
 
 
 


@SuppressWarnings("unused")
@FunctionTemplate(name = "newPartitionValue", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
public static class NewValueBitNullable implements SimpleFunction{

  @Param NullableBitHolder in;
  @Workspace NullableBitHolder previous;
  @Workspace Boolean initialized;
  @Output NullableBitHolder out;

  public void setup() {
    initialized = false;
  }

  public void eval() {
    if (initialized && // it's not the first value
      in.isSet == previous.isSet && // nullability didn't change
      (in.isSet == 0 || in.value == previous.value)) { // it's either a null partition or the value didn't change
      out.value = 0;
    } else { // start a new partition
      previous.value = in.value;
      previous.isSet = in.isSet;
      out.value = 1;
      initialized = true;
    }
    
    out.isSet = 1;
  }
}
 

 
 
 
 
}
