


package com.dremio.exec.expr.fn.impl;


import static com.google.common.base.Preconditions.checkArgument;
import static com.google.common.base.Preconditions.checkState;

import com.google.common.collect.Lists;
import com.google.common.collect.ObjectArrays;
import com.google.common.base.Charsets;
import com.google.common.collect.ObjectArrays;

import com.google.common.base.Preconditions;
import io.netty.buffer.NettyArrowBuf;

import org.apache.commons.lang3.ArrayUtils;

import com.dremio.common.exceptions.UserException;
import com.dremio.exec.expr.fn.impl.StringFunctionUtil;
import org.apache.arrow.memory.*;
import com.dremio.exec.proto.SchemaDefProtos;
import com.dremio.exec.proto.UserBitShared;
import com.dremio.exec.proto.UserBitShared.DremioPBError;
import com.dremio.exec.proto.UserBitShared.SerializedField;
import com.dremio.exec.record.*;
import com.dremio.common.exceptions.*;
import com.dremio.exec.exception.*;
import com.dremio.common.expression.FieldReference;
import org.apache.arrow.vector.util.*;
import org.apache.arrow.vector.*;
import org.apache.arrow.vector.complex.*;
import org.apache.arrow.vector.types.Types;
import org.apache.arrow.vector.types.Types.*;
import org.apache.arrow.vector.holders.*;
import com.dremio.exec.expr.TypeHelper;
import com.dremio.common.util.DremioStringUtils;
import com.dremio.exec.vector.*;
import com.dremio.exec.vector.complex.*;

import org.apache.arrow.memory.OutOfMemoryException;

import com.sun.codemodel.JType;
import com.sun.codemodel.JCodeModel;

import javax.inject.Inject;

import java.util.Arrays;
import java.util.Random;
import java.util.List;

import java.io.Closeable;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.nio.ByteBuffer;

import java.sql.Date;
import java.sql.Time;
import java.sql.Timestamp;
import java.math.BigDecimal;
import java.math.BigInteger;

import org.joda.time.LocalDateTime;
import org.joda.time.Period;

import com.dremio.exec.vector.accessor.sql.TimePrintMillis;
import javax.inject.Inject;





import com.dremio.exec.expr.SimpleFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.NullHandling;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import org.apache.arrow.vector.holders.*;
import org.apache.arrow.vector.complex.impl.*;
import javax.inject.Inject;
        import org.apache.arrow.memory.ArrowBuf;

/*
 * This class is generated using freemarker and the UnionFunctions.java template.
 */

@SuppressWarnings("unused")
/**
 * Additional functions can be found in the class UnionFunctions
 */
public class GUnionFunctions {


  @SuppressWarnings("unused")
  @FunctionTemplate(name = "IS_INT", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class UnionIsInt implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableBitHolder out;

    public void setup() {}

    public void eval() {
      out.isSet = 1;
      if (in.isSet == 1) {
        out.value = in.getMinorType() == org.apache.arrow.vector.types.Types.MinorType.INT ? 1 : 0;
      } else {
        out.value = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "ASSERT_INT", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastUnionInt implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableIntHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        in.reader.read(out);
      } else {
        out.isSet = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "castUNION", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastToUnionInt implements SimpleFunction {

    @Param NullableIntHolder in;
    @Output UnionHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        org.apache.arrow.vector.complex.impl.NullableIntHolderReaderImpl holderReaderImpl = new org.apache.arrow.vector.complex.impl.NullableIntHolderReaderImpl(in);
        out.reader = holderReaderImpl;
        out.isSet = 1;
      } else {
        out.isSet = 0;
      }
    }
  }


  @SuppressWarnings("unused")
  @FunctionTemplate(name = "IS_FLOAT4", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class UnionIsFloat4 implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableBitHolder out;

    public void setup() {}

    public void eval() {
      out.isSet = 1;
      if (in.isSet == 1) {
        out.value = in.getMinorType() == org.apache.arrow.vector.types.Types.MinorType.FLOAT4 ? 1 : 0;
      } else {
        out.value = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "ASSERT_FLOAT4", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastUnionFloat4 implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableFloat4Holder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        in.reader.read(out);
      } else {
        out.isSet = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "castUNION", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastToUnionFloat4 implements SimpleFunction {

    @Param NullableFloat4Holder in;
    @Output UnionHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        org.apache.arrow.vector.complex.impl.NullableFloat4HolderReaderImpl holderReaderImpl = new org.apache.arrow.vector.complex.impl.NullableFloat4HolderReaderImpl(in);
        out.reader = holderReaderImpl;
        out.isSet = 1;
      } else {
        out.isSet = 0;
      }
    }
  }


  @SuppressWarnings("unused")
  @FunctionTemplate(name = "IS_INTERVALYEAR", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class UnionIsIntervalYear implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableBitHolder out;

    public void setup() {}

    public void eval() {
      out.isSet = 1;
      if (in.isSet == 1) {
        out.value = in.getMinorType() == org.apache.arrow.vector.types.Types.MinorType.INTERVALYEAR ? 1 : 0;
      } else {
        out.value = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "ASSERT_INTERVALYEAR", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastUnionIntervalYear implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableIntervalYearHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        in.reader.read(out);
      } else {
        out.isSet = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "castUNION", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastToUnionIntervalYear implements SimpleFunction {

    @Param NullableIntervalYearHolder in;
    @Output UnionHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        org.apache.arrow.vector.complex.impl.NullableIntervalYearHolderReaderImpl holderReaderImpl = new org.apache.arrow.vector.complex.impl.NullableIntervalYearHolderReaderImpl(in);
        out.reader = holderReaderImpl;
        out.isSet = 1;
      } else {
        out.isSet = 0;
      }
    }
  }


  @SuppressWarnings("unused")
  @FunctionTemplate(name = "IS_TIME", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class UnionIsTimeMilli implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableBitHolder out;

    public void setup() {}

    public void eval() {
      out.isSet = 1;
      if (in.isSet == 1) {
        out.value = in.getMinorType() == org.apache.arrow.vector.types.Types.MinorType.TIMEMILLI ? 1 : 0;
      } else {
        out.value = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "ASSERT_TIME", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastUnionTimeMilli implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableTimeMilliHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        in.reader.read(out);
      } else {
        out.isSet = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "castUNION", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastToUnionTimeMilli implements SimpleFunction {

    @Param NullableTimeMilliHolder in;
    @Output UnionHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        org.apache.arrow.vector.complex.impl.NullableTimeMilliHolderReaderImpl holderReaderImpl = new org.apache.arrow.vector.complex.impl.NullableTimeMilliHolderReaderImpl(in);
        out.reader = holderReaderImpl;
        out.isSet = 1;
      } else {
        out.isSet = 0;
      }
    }
  }


  @SuppressWarnings("unused")
  @FunctionTemplate(name = "IS_BIGINT", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class UnionIsBigInt implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableBitHolder out;

    public void setup() {}

    public void eval() {
      out.isSet = 1;
      if (in.isSet == 1) {
        out.value = in.getMinorType() == org.apache.arrow.vector.types.Types.MinorType.BIGINT ? 1 : 0;
      } else {
        out.value = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "ASSERT_BIGINT", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastUnionBigInt implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableBigIntHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        in.reader.read(out);
      } else {
        out.isSet = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "castUNION", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastToUnionBigInt implements SimpleFunction {

    @Param NullableBigIntHolder in;
    @Output UnionHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        org.apache.arrow.vector.complex.impl.NullableBigIntHolderReaderImpl holderReaderImpl = new org.apache.arrow.vector.complex.impl.NullableBigIntHolderReaderImpl(in);
        out.reader = holderReaderImpl;
        out.isSet = 1;
      } else {
        out.isSet = 0;
      }
    }
  }


  @SuppressWarnings("unused")
  @FunctionTemplate(name = "IS_FLOAT8", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class UnionIsFloat8 implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableBitHolder out;

    public void setup() {}

    public void eval() {
      out.isSet = 1;
      if (in.isSet == 1) {
        out.value = in.getMinorType() == org.apache.arrow.vector.types.Types.MinorType.FLOAT8 ? 1 : 0;
      } else {
        out.value = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "ASSERT_FLOAT8", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastUnionFloat8 implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableFloat8Holder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        in.reader.read(out);
      } else {
        out.isSet = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "castUNION", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastToUnionFloat8 implements SimpleFunction {

    @Param NullableFloat8Holder in;
    @Output UnionHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        org.apache.arrow.vector.complex.impl.NullableFloat8HolderReaderImpl holderReaderImpl = new org.apache.arrow.vector.complex.impl.NullableFloat8HolderReaderImpl(in);
        out.reader = holderReaderImpl;
        out.isSet = 1;
      } else {
        out.isSet = 0;
      }
    }
  }


  @SuppressWarnings("unused")
  @FunctionTemplate(name = "IS_DATE", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class UnionIsDateMilli implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableBitHolder out;

    public void setup() {}

    public void eval() {
      out.isSet = 1;
      if (in.isSet == 1) {
        out.value = in.getMinorType() == org.apache.arrow.vector.types.Types.MinorType.DATEMILLI ? 1 : 0;
      } else {
        out.value = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "ASSERT_DATE", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastUnionDateMilli implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableDateMilliHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        in.reader.read(out);
      } else {
        out.isSet = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "castUNION", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastToUnionDateMilli implements SimpleFunction {

    @Param NullableDateMilliHolder in;
    @Output UnionHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        org.apache.arrow.vector.complex.impl.NullableDateMilliHolderReaderImpl holderReaderImpl = new org.apache.arrow.vector.complex.impl.NullableDateMilliHolderReaderImpl(in);
        out.reader = holderReaderImpl;
        out.isSet = 1;
      } else {
        out.isSet = 0;
      }
    }
  }


  @SuppressWarnings("unused")
  @FunctionTemplate(name = "IS_TIMESTAMP", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class UnionIsTimeStampMilli implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableBitHolder out;

    public void setup() {}

    public void eval() {
      out.isSet = 1;
      if (in.isSet == 1) {
        out.value = in.getMinorType() == org.apache.arrow.vector.types.Types.MinorType.TIMESTAMPMILLI ? 1 : 0;
      } else {
        out.value = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "ASSERT_TIMESTAMP", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastUnionTimeStampMilli implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableTimeStampMilliHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        in.reader.read(out);
      } else {
        out.isSet = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "castUNION", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastToUnionTimeStampMilli implements SimpleFunction {

    @Param NullableTimeStampMilliHolder in;
    @Output UnionHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        org.apache.arrow.vector.complex.impl.NullableTimeStampMilliHolderReaderImpl holderReaderImpl = new org.apache.arrow.vector.complex.impl.NullableTimeStampMilliHolderReaderImpl(in);
        out.reader = holderReaderImpl;
        out.isSet = 1;
      } else {
        out.isSet = 0;
      }
    }
  }


  @SuppressWarnings("unused")
  @FunctionTemplate(name = "IS_INTERVALDAY", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class UnionIsIntervalDay implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableBitHolder out;

    public void setup() {}

    public void eval() {
      out.isSet = 1;
      if (in.isSet == 1) {
        out.value = in.getMinorType() == org.apache.arrow.vector.types.Types.MinorType.INTERVALDAY ? 1 : 0;
      } else {
        out.value = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "ASSERT_INTERVALDAY", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastUnionIntervalDay implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableIntervalDayHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        in.reader.read(out);
      } else {
        out.isSet = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "castUNION", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastToUnionIntervalDay implements SimpleFunction {

    @Param NullableIntervalDayHolder in;
    @Output UnionHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        org.apache.arrow.vector.complex.impl.NullableIntervalDayHolderReaderImpl holderReaderImpl = new org.apache.arrow.vector.complex.impl.NullableIntervalDayHolderReaderImpl(in);
        out.reader = holderReaderImpl;
        out.isSet = 1;
      } else {
        out.isSet = 0;
      }
    }
  }


  @SuppressWarnings("unused")
  @FunctionTemplate(name = "IS_FIXEDSIZEBINARY", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class UnionIsFixedSizeBinary implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableBitHolder out;

    public void setup() {}

    public void eval() {
      out.isSet = 1;
      if (in.isSet == 1) {
        out.value = in.getMinorType() == org.apache.arrow.vector.types.Types.MinorType.FIXEDSIZEBINARY ? 1 : 0;
      } else {
        out.value = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "ASSERT_FIXEDSIZEBINARY", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastUnionFixedSizeBinary implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableFixedSizeBinaryHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        in.reader.read(out);
      } else {
        out.isSet = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "castUNION", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastToUnionFixedSizeBinary implements SimpleFunction {

    @Param NullableFixedSizeBinaryHolder in;
    @Output UnionHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        org.apache.arrow.vector.complex.impl.NullableFixedSizeBinaryHolderReaderImpl holderReaderImpl = new org.apache.arrow.vector.complex.impl.NullableFixedSizeBinaryHolderReaderImpl(in);
        out.reader = holderReaderImpl;
        out.isSet = 1;
      } else {
        out.isSet = 0;
      }
    }
  }


  @SuppressWarnings("unused")
  @FunctionTemplate(name = "IS_VARBINARY", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class UnionIsVarBinary implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableBitHolder out;

    public void setup() {}

    public void eval() {
      out.isSet = 1;
      if (in.isSet == 1) {
        out.value = in.getMinorType() == org.apache.arrow.vector.types.Types.MinorType.VARBINARY ? 1 : 0;
      } else {
        out.value = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "ASSERT_VARBINARY", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastUnionVarBinary implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableVarBinaryHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        in.reader.read(out);
      } else {
        out.isSet = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "castUNION", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastToUnionVarBinary implements SimpleFunction {

    @Param NullableVarBinaryHolder in;
    @Output UnionHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        org.apache.arrow.vector.complex.impl.NullableVarBinaryHolderReaderImpl holderReaderImpl = new org.apache.arrow.vector.complex.impl.NullableVarBinaryHolderReaderImpl(in);
        out.reader = holderReaderImpl;
        out.isSet = 1;
      } else {
        out.isSet = 0;
      }
    }
  }


  @SuppressWarnings("unused")
  @FunctionTemplate(name = "IS_VARCHAR", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class UnionIsVarChar implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableBitHolder out;

    public void setup() {}

    public void eval() {
      out.isSet = 1;
      if (in.isSet == 1) {
        out.value = in.getMinorType() == org.apache.arrow.vector.types.Types.MinorType.VARCHAR ? 1 : 0;
      } else {
        out.value = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "ASSERT_VARCHAR", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastUnionVarChar implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableVarCharHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        in.reader.read(out);
      } else {
        out.isSet = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "castUNION", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastToUnionVarChar implements SimpleFunction {

    @Param NullableVarCharHolder in;
    @Output UnionHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        org.apache.arrow.vector.complex.impl.NullableVarCharHolderReaderImpl holderReaderImpl = new org.apache.arrow.vector.complex.impl.NullableVarCharHolderReaderImpl(in);
        out.reader = holderReaderImpl;
        out.isSet = 1;
      } else {
        out.isSet = 0;
      }
    }
  }


  @SuppressWarnings("unused")
  @FunctionTemplate(name = "IS_BIT", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class UnionIsBit implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableBitHolder out;

    public void setup() {}

    public void eval() {
      out.isSet = 1;
      if (in.isSet == 1) {
        out.value = in.getMinorType() == org.apache.arrow.vector.types.Types.MinorType.BIT ? 1 : 0;
      } else {
        out.value = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "ASSERT_BIT", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastUnionBit implements SimpleFunction {

    @Param UnionHolder in;
    @Output NullableBitHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        in.reader.read(out);
      } else {
        out.isSet = 0;
      }
    }
  }

  @SuppressWarnings("unused")
  @FunctionTemplate(name = "castUNION", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.INTERNAL)
  public static class CastToUnionBit implements SimpleFunction {

    @Param NullableBitHolder in;
    @Output UnionHolder out;

    public void setup() {}

    public void eval() {
      if (in.isSet == 1) {
        org.apache.arrow.vector.complex.impl.NullableBitHolderReaderImpl holderReaderImpl = new org.apache.arrow.vector.complex.impl.NullableBitHolderReaderImpl(in);
        out.reader = holderReaderImpl;
        out.isSet = 1;
      } else {
        out.isSet = 0;
      }
    }
  }


}
