

package com.dremio.exec.expr.fn.impl;

import io.netty.buffer.ByteBuf;

import com.dremio.exec.expr.SimpleFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.NullHandling;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.annotations.Workspace;
import org.apache.arrow.vector.holders.*;
import org.joda.time.DateTimeZone;
import org.joda.time.DateMidnight;
import org.apache.arrow.vector.util.DateUtility;

/**
 * generated from DateIntervalFunctionTemplates/IntervalIntervalArithmetic.java
 */
public class IntervalDayFunctions {

    @SuppressWarnings("unused")
    @FunctionTemplate(name = "add", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.NULL_IF_NULL)
    public static class IntervalDayAddFunction implements SimpleFunction {
    @Param IntervalDayHolder left;
    @Param IntervalDayHolder right;
    @Output IntervalDayHolder out;

        public void setup() {
        }

        public void eval() {
            out.days = left.days + right.days;
            out.milliseconds = left.milliseconds + right.milliseconds;
        }
    }

    @SuppressWarnings("unused")
    @FunctionTemplate(name = "subtract", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.NULL_IF_NULL)
    public static class IntervalDaySubtractFunction implements SimpleFunction {
    @Param IntervalDayHolder left;
    @Param IntervalDayHolder right;
    @Output IntervalDayHolder out;

        public void setup() {
        }

        public void eval() {
            out.days = left.days - right.days;
            out.milliseconds = left.milliseconds - right.milliseconds;
        }
    }
    @SuppressWarnings("unused")
    @FunctionTemplate(names = {"negative", "u-", "-"}, scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.NULL_IF_NULL)
    public static class IntervalDayNegateFunction implements SimpleFunction {
    @Param IntervalDayHolder left;
    @Output IntervalDayHolder out;

        public void setup() {
        }

        public void eval() {
            out.days = -left.days;
            out.milliseconds = -left.milliseconds;
        }
    }
}

