

package com.dremio.exec.expr.fn.impl;

import io.netty.buffer.ByteBuf;

import org.apache.arrow.vector.holders.*;
import com.dremio.exec.expr.SimpleFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.NullHandling;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.annotations.Workspace;
import org.joda.time.DateTimeZone;
import org.joda.time.DateMidnight;
import org.apache.arrow.vector.util.DateUtility;

/**
 * generated from DateIntervalFunctionTemplates/IntervalNumericArithmetic.java
 */
public class IntervalYearFloat8Functions {


    @SuppressWarnings("unused")
    @FunctionTemplate(name = "multiply", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.NULL_IF_NULL)
    public static class IntervalYearFloat8MultiplyFunction implements SimpleFunction {
    @Param IntervalYearHolder left;
    @Param Float8Holder right;
    @Output IntervalYearHolder out;

        public void setup() {
        }

        public void eval() {
    out.value = (int) (left.value * (double) right.value);
        }
    }

    @SuppressWarnings("unused")
    @FunctionTemplate(name = "multiply", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.NULL_IF_NULL)
    public static class Float8IntervalYearMultiplyFunction implements SimpleFunction {
    @Param Float8Holder right;
    @Param IntervalYearHolder left;
    @Output IntervalYearHolder out;

        public void setup() {
        }

        public void eval() {
    out.value = (int) (left.value * (double) right.value);
        }
    }

    @SuppressWarnings("unused")
    @FunctionTemplate(names = {"divide", "div"}, scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.NULL_IF_NULL)
    public static class IntervalYearFloat8DivideFunction implements SimpleFunction {
    @Param IntervalYearHolder left;
    @Param Float8Holder right;
    @Output IntervalYearHolder out;

        public void setup() {
        }

        public void eval() {
    out.value = (int) (left.value / (double) right.value);
        }
    }
}
