

package com.dremio.exec.expr.fn.impl;

import io.netty.buffer.ByteBuf;

import com.dremio.exec.expr.SimpleFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.NullHandling;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.annotations.Workspace;
import org.apache.arrow.vector.holders.*;
import org.joda.time.DateTimeZone;
import org.joda.time.DateMidnight;
import org.apache.arrow.vector.util.DateUtility;

/**
 * generated from DateIntervalFunctionTemplates/IntervalIntervalArithmetic.java
 */
public class IntervalYearFunctions {

    @SuppressWarnings("unused")
    @FunctionTemplate(name = "add", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.NULL_IF_NULL)
    public static class IntervalYearAddFunction implements SimpleFunction {
    @Param IntervalYearHolder left;
    @Param IntervalYearHolder right;
    @Output IntervalYearHolder out;

        public void setup() {
        }

        public void eval() {
            out.value = left.value + right.value;
        }
    }

    @SuppressWarnings("unused")
    @FunctionTemplate(name = "subtract", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.NULL_IF_NULL)
    public static class IntervalYearSubtractFunction implements SimpleFunction {
    @Param IntervalYearHolder left;
    @Param IntervalYearHolder right;
    @Output IntervalYearHolder out;

        public void setup() {
        }

        public void eval() {
            out.value = left.value - right.value;
        }
    }
    @SuppressWarnings("unused")
    @FunctionTemplate(names = {"negative", "u-", "-"}, scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.NULL_IF_NULL)
    public static class IntervalYearNegateFunction implements SimpleFunction {
    @Param IntervalYearHolder left;
    @Output IntervalYearHolder out;

        public void setup() {
        }

        public void eval() {
            out.value = -left.value;
        }
    }
}
