

package com.dremio.exec.expr.fn.impl;

import io.netty.buffer.ByteBuf;

import com.dremio.exec.expr.SimpleFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.NullHandling;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.annotations.Workspace;
import com.dremio.exec.expr.fn.FunctionErrorContext;
import org.apache.arrow.vector.holders.*;
import org.joda.time.MutableDateTime;
import org.joda.time.DateTimeZone;
import org.joda.time.DateMidnight;
import org.apache.arrow.vector.util.DateUtility;
import javax.inject.Inject;

/**
 * generated from DateIntervalFunctionTemplates/DateIntervalArithmeticFunctions.java TimeMilli Int
 */
public class TimeMilliIntFunctions {

    @SuppressWarnings("unused")
    @FunctionTemplate(names = {"date_add", "add"}, scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.NULL_IF_NULL)
    public static class TimeMilliIntAddFunction implements SimpleFunction {
    @Param TimeMilliHolder left;
    @Param IntHolder right;
    @Output TimeMilliHolder out;
    @Inject FunctionErrorContext errCtx;

        public void setup() {
        }

        @SuppressWarnings("IdentityBinaryExpression")
        public void eval() {
    if (1 == 1) {
        throw errCtx.error()
          .message("Cannot add integer to TIME, cast it to specific interval")
          .build();
    }
        }
    }

    @SuppressWarnings("unused")
    @FunctionTemplate(names = {"date_add", "add"}, scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.NULL_IF_NULL)
    public static class IntTimeMilliAddFunction implements SimpleFunction {
    @Param IntHolder right;
    @Param TimeMilliHolder left;
    @Output TimeMilliHolder out;
    @Inject FunctionErrorContext errCtx;

        public void setup() {
        }

        @SuppressWarnings("IdentityBinaryExpression")
        public void eval() {
    if (1 == 1) {
        throw errCtx.error()
          .message("Cannot add integer to TIME, cast it to specific interval")
          .build();
    }
        }
    }

    @SuppressWarnings("unused")
    @FunctionTemplate(names = {"date_sub", "subtract", "date_diff"}, scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.NULL_IF_NULL)
    public static class TimeMilliIntSubtractFunction implements SimpleFunction {
    @Param TimeMilliHolder left;
    @Param IntHolder right;
    @Output TimeMilliHolder out;
    @Inject FunctionErrorContext errCtx;

        public void setup() {
        }

        @SuppressWarnings("IdentityBinaryExpression")
        public void eval() {
    if (1 == 1) {
        throw errCtx.error()
          .message("Cannot add integer to TIME, cast it to specific interval")
          .build();
    }
        }
    }
}

