

package com.dremio.exec.expr.fn.impl;

import io.netty.buffer.ByteBuf;

import com.dremio.exec.expr.SimpleFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.NullHandling;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.annotations.Workspace;
import com.dremio.exec.expr.fn.FunctionErrorContext;
import org.apache.arrow.vector.holders.*;
import org.joda.time.MutableDateTime;
import org.joda.time.DateTimeZone;
import org.joda.time.DateMidnight;
import org.apache.arrow.vector.util.DateUtility;
import javax.inject.Inject;

/**
 * generated from DateIntervalFunctionTemplates/DateIntervalArithmeticFunctions.java TimeMilli IntervalYear
 */
public class TimeMilliIntervalYearFunctions {

    @SuppressWarnings("unused")
    @FunctionTemplate(names = {"date_add", "add"}, scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.NULL_IF_NULL)
    public static class TimeMilliIntervalYearAddFunction implements SimpleFunction {
    @Param TimeMilliHolder left;
    @Param IntervalYearHolder right;
    @Output TimeMilliHolder out;
    @Inject FunctionErrorContext errCtx;

        public void setup() {
        }

        @SuppressWarnings("IdentityBinaryExpression")
        public void eval() {
    // Needn't add anything to time from interval year data type. Output is same as input
    out.value = left.value;
        }
    }

    @SuppressWarnings("unused")
    @FunctionTemplate(names = {"date_add", "add"}, scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.NULL_IF_NULL)
    public static class IntervalYearTimeMilliAddFunction implements SimpleFunction {
    @Param IntervalYearHolder right;
    @Param TimeMilliHolder left;
    @Output TimeMilliHolder out;
    @Inject FunctionErrorContext errCtx;

        public void setup() {
        }

        @SuppressWarnings("IdentityBinaryExpression")
        public void eval() {
    // Needn't add anything to time from interval year data type. Output is same as input
    out.value = left.value;
        }
    }

    @SuppressWarnings("unused")
    @FunctionTemplate(names = {"date_sub", "subtract", "date_diff"}, scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.NULL_IF_NULL)
    public static class TimeMilliIntervalYearSubtractFunction implements SimpleFunction {
    @Param TimeMilliHolder left;
    @Param IntervalYearHolder right;
    @Output TimeMilliHolder out;
    @Inject FunctionErrorContext errCtx;

        public void setup() {
        }

        @SuppressWarnings("IdentityBinaryExpression")
        public void eval() {
    // Needn't add anything to time from interval year data type. Output is same as input
    out.value = left.value;
        }
    }
}

