

package com.dremio.exec.expr.fn.impl;

import io.netty.buffer.ByteBuf;

import com.dremio.exec.expr.SimpleFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.NullHandling;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.annotations.Workspace;
import com.dremio.exec.expr.fn.FunctionErrorContext;
import org.apache.arrow.vector.holders.*;
import org.joda.time.MutableDateTime;
import org.joda.time.DateTimeZone;
import org.joda.time.DateMidnight;
import org.apache.arrow.vector.util.DateUtility;
import javax.inject.Inject;

/**
 * generated from DateIntervalFunctionTemplates/DateIntervalArithmeticFunctions.java
 */
public class TimeStampMilliIntervalYearFunctions {


    @SuppressWarnings("unused")
    @FunctionTemplate(names = {"date_add", "add"}, scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.NULL_IF_NULL)
    public static class TimeStampMilliIntervalYearAddFunction implements SimpleFunction {
    @Param TimeStampMilliHolder left;
    @Param IntervalYearHolder right;
    @Workspace org.joda.time.MutableDateTime temp;
    @Output TimeStampMilliHolder out;
    @Inject FunctionErrorContext errCtx;
        public void setup() {
            temp = new org.joda.time.MutableDateTime(org.joda.time.DateTimeZone.UTC);
        }

        @SuppressWarnings("IdentityBinaryExpression")
        public void eval() {

    temp.setMillis(left.value);

    temp.addMonths(right.value );

    out.value = temp.getMillis();
        }
    }

    @SuppressWarnings("unused")
    @FunctionTemplate(names = {"date_add", "add"}, scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.NULL_IF_NULL)
    public static class IntervalYearTimeStampMilliAddFunction implements SimpleFunction {

    @Param IntervalYearHolder right;
    @Param TimeStampMilliHolder left;
    @Workspace org.joda.time.MutableDateTime temp;
    @Output TimeStampMilliHolder out;
    @Inject FunctionErrorContext errCtx;
        public void setup() {
            temp = new org.joda.time.MutableDateTime(org.joda.time.DateTimeZone.UTC);
        }

        @SuppressWarnings("IdentityBinaryExpression")
        public void eval() {


    temp.setMillis(left.value);

    temp.addMonths(right.value );

    out.value = temp.getMillis();
        }
    }

    @SuppressWarnings("unused")
    @FunctionTemplate(names = {"date_sub", "subtract", "date_diff"}, scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.NULL_IF_NULL)
    public static class TimeStampMilliIntervalYearSubtractFunction implements SimpleFunction {
    @Param TimeStampMilliHolder left;
    @Param IntervalYearHolder right;
    @Workspace org.joda.time.MutableDateTime temp;
    @Output TimeStampMilliHolder out;
    @Inject FunctionErrorContext errCtx;

        public void setup() {
            temp = new org.joda.time.MutableDateTime(org.joda.time.DateTimeZone.UTC);
        }

        @SuppressWarnings("IdentityBinaryExpression")
        public void eval() {

    temp.setMillis(left.value);

    temp.addMonths(right.value  * -1 );

    out.value = temp.getMillis();
        }
    }
}

