
//////////////////////////////////////////////////////////////////////////////////////////////////
//Functions for Trigo Math Functions
//////////////////////////////////////////////////////////////////////////////////////////////////


package com.dremio.exec.expr.fn.impl;

import com.dremio.common.types.TypeProtos;
import com.dremio.common.types.Types;
import com.dremio.common.types.TypeProtos.MinorType;
import com.dremio.exec.expr.SimpleFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.FunctionScope;
import com.dremio.exec.expr.annotations.FunctionTemplate.FunctionScope;
import com.dremio.exec.expr.annotations.FunctionTemplate.NullHandling;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.annotations.Workspace;
import com.dremio.exec.expr.fn.impl.StringFunctions;
import org.apache.arrow.vector.holders.*;

/*
 * This class is automatically generated from MathFunc.tdd using FreeMarker.
 */

@SuppressWarnings("unused")
/**
 * generated from MathFunctions.java 
 */
public class TrigoMathFunctions{
  static final org.slf4j.Logger logger = org.slf4j.LoggerFactory.getLogger(TrigoMathFunctions.class);

  private TrigoMathFunctions(){}



  @FunctionTemplate(name = "sin", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class SinInt implements SimpleFunction {

    @Param IntHolder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.sin(in.value);
    }
  }

  @FunctionTemplate(name = "sin", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class SinBigInt implements SimpleFunction {

    @Param BigIntHolder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.sin(in.value);
    }
  }

  @FunctionTemplate(name = "sin", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class SinFloat4 implements SimpleFunction {

    @Param Float4Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.sin(in.value);
    }
  }

  @FunctionTemplate(name = "sin", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class SinFloat8 implements SimpleFunction {

    @Param Float8Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.sin(in.value);
    }
  }


  @FunctionTemplate(name = "cos", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class CosInt implements SimpleFunction {

    @Param IntHolder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.cos(in.value);
    }
  }

  @FunctionTemplate(name = "cos", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class CosBigInt implements SimpleFunction {

    @Param BigIntHolder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.cos(in.value);
    }
  }

  @FunctionTemplate(name = "cos", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class CosFloat4 implements SimpleFunction {

    @Param Float4Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.cos(in.value);
    }
  }

  @FunctionTemplate(name = "cos", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class CosFloat8 implements SimpleFunction {

    @Param Float8Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.cos(in.value);
    }
  }


  @FunctionTemplate(name = "tan", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class TanInt implements SimpleFunction {

    @Param IntHolder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.tan(in.value);
    }
  }

  @FunctionTemplate(name = "tan", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class TanBigInt implements SimpleFunction {

    @Param BigIntHolder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.tan(in.value);
    }
  }

  @FunctionTemplate(name = "tan", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class TanFloat4 implements SimpleFunction {

    @Param Float4Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.tan(in.value);
    }
  }

  @FunctionTemplate(name = "tan", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class TanFloat8 implements SimpleFunction {

    @Param Float8Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.tan(in.value);
    }
  }


  @FunctionTemplate(name = "asin", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class ASinInt implements SimpleFunction {

    @Param IntHolder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.asin(in.value);
    }
  }

  @FunctionTemplate(name = "asin", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class ASinBigInt implements SimpleFunction {

    @Param BigIntHolder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.asin(in.value);
    }
  }

  @FunctionTemplate(name = "asin", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class ASinFloat4 implements SimpleFunction {

    @Param Float4Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.asin(in.value);
    }
  }

  @FunctionTemplate(name = "asin", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class ASinFloat8 implements SimpleFunction {

    @Param Float8Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.asin(in.value);
    }
  }


  @FunctionTemplate(name = "acos", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class ACosInt implements SimpleFunction {

    @Param IntHolder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.acos(in.value);
    }
  }

  @FunctionTemplate(name = "acos", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class ACosBigInt implements SimpleFunction {

    @Param BigIntHolder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.acos(in.value);
    }
  }

  @FunctionTemplate(name = "acos", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class ACosFloat4 implements SimpleFunction {

    @Param Float4Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.acos(in.value);
    }
  }

  @FunctionTemplate(name = "acos", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class ACosFloat8 implements SimpleFunction {

    @Param Float8Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.acos(in.value);
    }
  }


  @FunctionTemplate(name = "atan", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class ATanInt implements SimpleFunction {

    @Param IntHolder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.atan(in.value);
    }
  }

  @FunctionTemplate(name = "atan", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class ATanBigInt implements SimpleFunction {

    @Param BigIntHolder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.atan(in.value);
    }
  }

  @FunctionTemplate(name = "atan", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class ATanFloat4 implements SimpleFunction {

    @Param Float4Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.atan(in.value);
    }
  }

  @FunctionTemplate(name = "atan", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class ATanFloat8 implements SimpleFunction {

    @Param Float8Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.atan(in.value);
    }
  }


  @FunctionTemplate(name = "sinh", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class SinhInt implements SimpleFunction {

    @Param IntHolder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.sinh(in.value);
    }
  }

  @FunctionTemplate(name = "sinh", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class SinhBigInt implements SimpleFunction {

    @Param BigIntHolder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.sinh(in.value);
    }
  }

  @FunctionTemplate(name = "sinh", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class SinhFloat4 implements SimpleFunction {

    @Param Float4Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.sinh(in.value);
    }
  }

  @FunctionTemplate(name = "sinh", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class SinhFloat8 implements SimpleFunction {

    @Param Float8Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.sinh(in.value);
    }
  }


  @FunctionTemplate(name = "cosh", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class CoshInt implements SimpleFunction {

    @Param IntHolder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.cosh(in.value);
    }
  }

  @FunctionTemplate(name = "cosh", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class CoshBigInt implements SimpleFunction {

    @Param BigIntHolder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.cosh(in.value);
    }
  }

  @FunctionTemplate(name = "cosh", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class CoshFloat4 implements SimpleFunction {

    @Param Float4Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.cosh(in.value);
    }
  }

  @FunctionTemplate(name = "cosh", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class CoshFloat8 implements SimpleFunction {

    @Param Float8Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.cosh(in.value);
    }
  }


  @FunctionTemplate(name = "tanh", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class TanhInt implements SimpleFunction {

    @Param IntHolder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.tanh(in.value);
    }
  }

  @FunctionTemplate(name = "tanh", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class TanhBigInt implements SimpleFunction {

    @Param BigIntHolder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.tanh(in.value);
    }
  }

  @FunctionTemplate(name = "tanh", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class TanhFloat4 implements SimpleFunction {

    @Param Float4Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.tanh(in.value);
    }
  }

  @FunctionTemplate(name = "tanh", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class TanhFloat8 implements SimpleFunction {

    @Param Float8Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.tanh(in.value);
    }
  }


  @FunctionTemplate(name = "cot", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class CotInt implements SimpleFunction {

    @Param IntHolder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = 1.0/java.lang.Math.tan(in.value);
    }
  }

  @FunctionTemplate(name = "cot", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class CotBigInt implements SimpleFunction {

    @Param BigIntHolder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = 1.0/java.lang.Math.tan(in.value);
    }
  }

  @FunctionTemplate(name = "cot", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class CotFloat4 implements SimpleFunction {

    @Param Float4Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = 1.0/java.lang.Math.tan(in.value);
    }
  }

  @FunctionTemplate(name = "cot", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class CotFloat8 implements SimpleFunction {

    @Param Float8Holder in;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = 1.0/java.lang.Math.tan(in.value);
    }
  }



  @FunctionTemplate(name = "atan2", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class ATan2Int implements SimpleFunction {

    @Param IntHolder in1;
    @Param IntHolder in2;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.atan2(in1.value, in2.value);
    }
  }

  @FunctionTemplate(name = "atan2", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class ATan2BigInt implements SimpleFunction {

    @Param BigIntHolder in1;
    @Param BigIntHolder in2;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.atan2(in1.value, in2.value);
    }
  }

  @FunctionTemplate(name = "atan2", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class ATan2Float4 implements SimpleFunction {

    @Param Float4Holder in1;
    @Param Float4Holder in2;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.atan2(in1.value, in2.value);
    }
  }

  @FunctionTemplate(name = "atan2", scope = FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
  public static class ATan2Float8 implements SimpleFunction {

    @Param Float8Holder in1;
    @Param Float8Holder in2;
    @Output Float8Holder out;

    public void setup() {
    }

    public void eval() {
      out.value = java.lang.Math.atan2(in1.value, in2.value);
    }
  }
}
