

// Source code generated using FreeMarker template AggrTypeFunctions2.java



package com.dremio.exec.expr.fn.impl.gaggr;

import com.dremio.exec.expr.AggrFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.FunctionScope;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.annotations.Workspace;
import org.apache.arrow.vector.holders.*;

@SuppressWarnings("unused")

/**
 * generated from AggrTypeFunctions2.java 
 */
public class AvgFunctions {
	static final org.slf4j.Logger logger = org.slf4j.LoggerFactory.getLogger(AvgFunctions.class);
 

@FunctionTemplate(name = "avg", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)

public static class NullableIntAvg implements AggrFunction{

  @Param NullableIntHolder in;
  @Workspace NullableBigIntHolder sum;
  @Workspace NullableBigIntHolder count;
  @Workspace NullableBigIntHolder nonNullCount;
  @Output NullableFloat8Holder out;

  public void setup() {
  	sum = new NullableBigIntHolder();  
    sum.isSet = 1;
    sum.value = 0;

    count = new NullableBigIntHolder();  
    count.isSet = 1;
    count.value = 0;

    nonNullCount = new NullableBigIntHolder();
  	nonNullCount.value = 0;
  	nonNullCount.isSet = 1;
  }
  
  @Override
  public void add() {
	    sout: {
	    if (in.isSet == 0) {
		    // processing nullable input and the value is null, so don't do anything...
		    break sout;
	    } 
    nonNullCount.value = 1;
 	    sum.value += in.value;
 	    count.value++;
    } // end of sout block
  }

  @Override
  public void output() {
    if (nonNullCount.value > 0) {
      out.value = sum.value / ((double) count.value);
      out.isSet = 1;
    } else {
      out.isSet = 0;
    }
  }

  @Override
  public void reset() {
    nonNullCount.value = 0;
    sum.value = 0;
    count.value = 0;
  }

 }


@FunctionTemplate(name = "avg", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)

public static class NullableBigIntAvg implements AggrFunction{

  @Param NullableBigIntHolder in;
  @Workspace NullableBigIntHolder sum;
  @Workspace NullableBigIntHolder count;
  @Workspace NullableBigIntHolder nonNullCount;
  @Output NullableFloat8Holder out;

  public void setup() {
  	sum = new NullableBigIntHolder();  
    sum.isSet = 1;
    sum.value = 0;

    count = new NullableBigIntHolder();  
    count.isSet = 1;
    count.value = 0;

    nonNullCount = new NullableBigIntHolder();
  	nonNullCount.value = 0;
  	nonNullCount.isSet = 1;
  }
  
  @Override
  public void add() {
	    sout: {
	    if (in.isSet == 0) {
		    // processing nullable input and the value is null, so don't do anything...
		    break sout;
	    } 
    nonNullCount.value = 1;
 	    sum.value += in.value;
 	    count.value++;
    } // end of sout block
  }

  @Override
  public void output() {
    if (nonNullCount.value > 0) {
      out.value = sum.value / ((double) count.value);
      out.isSet = 1;
    } else {
      out.isSet = 0;
    }
  }

  @Override
  public void reset() {
    nonNullCount.value = 0;
    sum.value = 0;
    count.value = 0;
  }

 }


@FunctionTemplate(name = "avg", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)

public static class NullableFloat4Avg implements AggrFunction{

  @Param NullableFloat4Holder in;
  @Workspace NullableFloat8Holder sum;
  @Workspace NullableBigIntHolder count;
  @Workspace NullableBigIntHolder nonNullCount;
  @Output NullableFloat8Holder out;

  public void setup() {
  	sum = new NullableFloat8Holder();  
    sum.isSet = 1;
    sum.value = 0;

    count = new NullableBigIntHolder();  
    count.isSet = 1;
    count.value = 0;

    nonNullCount = new NullableBigIntHolder();
  	nonNullCount.value = 0;
  	nonNullCount.isSet = 1;
  }
  
  @Override
  public void add() {
	    sout: {
	    if (in.isSet == 0) {
		    // processing nullable input and the value is null, so don't do anything...
		    break sout;
	    } 
    nonNullCount.value = 1;
 	    sum.value += in.value;
 	    count.value++;
    } // end of sout block
  }

  @Override
  public void output() {
    if (nonNullCount.value > 0) {
      out.value = sum.value / ((double) count.value);
      out.isSet = 1;
    } else {
      out.isSet = 0;
    }
  }

  @Override
  public void reset() {
    nonNullCount.value = 0;
    sum.value = 0;
    count.value = 0;
  }

 }


@FunctionTemplate(name = "avg", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)

public static class NullableFloat8Avg implements AggrFunction{

  @Param NullableFloat8Holder in;
  @Workspace NullableFloat8Holder sum;
  @Workspace NullableBigIntHolder count;
  @Workspace NullableBigIntHolder nonNullCount;
  @Output NullableFloat8Holder out;

  public void setup() {
  	sum = new NullableFloat8Holder();  
    sum.isSet = 1;
    sum.value = 0;

    count = new NullableBigIntHolder();  
    count.isSet = 1;
    count.value = 0;

    nonNullCount = new NullableBigIntHolder();
  	nonNullCount.value = 0;
  	nonNullCount.isSet = 1;
  }
  
  @Override
  public void add() {
	    sout: {
	    if (in.isSet == 0) {
		    // processing nullable input and the value is null, so don't do anything...
		    break sout;
	    } 
    nonNullCount.value = 1;
 	    sum.value += in.value;
 	    count.value++;
    } // end of sout block
  }

  @Override
  public void output() {
    if (nonNullCount.value > 0) {
      out.value = sum.value / ((double) count.value);
      out.isSet = 1;
    } else {
      out.isSet = 0;
    }
  }

  @Override
  public void reset() {
    nonNullCount.value = 0;
    sum.value = 0;
    count.value = 0;
  }

 }

}

