

// Source code generated using FreeMarker template IntervalAggrFunctions2.java


package com.dremio.exec.expr.fn.impl.gaggr;

import com.dremio.exec.expr.AggrFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.FunctionScope;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.annotations.Workspace;
import org.apache.arrow.vector.holders.*;

@SuppressWarnings("unused")

public class AvgIntervalTypeFunctions {
	static final org.slf4j.Logger logger = org.slf4j.LoggerFactory.getLogger(AvgFunctions.class);


@FunctionTemplate(name = "avg", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)

public static class NullableIntervalDayAvg implements AggrFunction{

  @Param NullableIntervalDayHolder in;
  @Workspace NullableBigIntHolder sum;
  @Workspace NullableBigIntHolder count;
  @Workspace BigIntHolder nonNullCount;
  @Output NullableIntervalDayHolder out;

  public void setup() {
  	sum = new NullableBigIntHolder();
    count = new NullableBigIntHolder();
    nonNullCount = new BigIntHolder();
    nonNullCount.value = 0;
    sum.value = 0;
    count.value = 0;
  }

  @Override
  public void add() {
	    sout: {
	    if (in.isSet == 0) {
		    // processing nullable input and the value is null, so don't do anything...
		    break sout;
	    }
    nonNullCount.value = 1;
    sum.value += (long) in.days * (org.apache.arrow.vector.util.DateUtility.daysToStandardMillis) +
                        in.milliseconds;
    count.value++;

    } // end of sout block
  }

  @Override
  public void output() {
    if (nonNullCount.value > 0) {
      out.isSet = 1;
      double millis = sum.value / ((double) count.value);
      out.days = (int) (millis / org.apache.arrow.vector.util.DateUtility.daysToStandardMillis);
      out.milliseconds = (int) (millis % org.apache.arrow.vector.util.DateUtility.daysToStandardMillis);
    } else {
      out.isSet = 0;
    }
  }

  @Override
  public void reset() {
    nonNullCount.value = 0;
    sum.value = 0;
    count.value = 0;
  }

 }


@FunctionTemplate(name = "avg", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)

public static class NullableIntervalYearAvg implements AggrFunction{

  @Param NullableIntervalYearHolder in;
  @Workspace NullableBigIntHolder sum;
  @Workspace NullableBigIntHolder count;
  @Workspace BigIntHolder nonNullCount;
  @Output NullableIntervalYearHolder out;

  public void setup() {
  	sum = new NullableBigIntHolder();
    count = new NullableBigIntHolder();
    nonNullCount = new BigIntHolder();
    nonNullCount.value = 0;
    sum.value = 0;
    count.value = 0;
  }

  @Override
  public void add() {
	    sout: {
	    if (in.isSet == 0) {
		    // processing nullable input and the value is null, so don't do anything...
		    break sout;
	    }
    nonNullCount.value = 1;
    sum.value += in.value;
    count.value++;

    } // end of sout block
  }

  @Override
  public void output() {
    if (nonNullCount.value > 0) {
      out.isSet = 1;
      double millis = sum.value / ((double) count.value);
      out.value = (int) (millis / org.apache.arrow.vector.util.DateUtility.monthsToMillis);
    } else {
      out.isSet = 0;
    }
  }

  @Override
  public void reset() {
    nonNullCount.value = 0;
    sum.value = 0;
    count.value = 0;
  }

 }

}

