


/*
 * This class is automatically generated from CorrelationTypes.tdd using FreeMarker.
 */

package com.dremio.exec.expr.fn.impl.gaggr;

import com.dremio.exec.expr.AggrFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.NullHandling;
import com.dremio.exec.expr.annotations.FunctionTemplate.FunctionScope;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.annotations.Workspace;
import org.apache.arrow.vector.holders.BigIntHolder;
import org.apache.arrow.vector.holders.NullableBigIntHolder;
import org.apache.arrow.vector.holders.IntHolder;
import org.apache.arrow.vector.holders.NullableIntHolder;
import org.apache.arrow.vector.holders.NullableFloat8Holder;
import org.apache.arrow.vector.holders.NullableFloat4Holder;
import org.apache.arrow.vector.holders.Float8Holder;
import org.apache.arrow.vector.holders.Float4Holder;

@SuppressWarnings("unused")

public class CorrelationFunctions {
	static final org.slf4j.Logger logger = org.slf4j.LoggerFactory.getLogger(CorrelationFunctions.class);


@FunctionTemplate(names = {"corr", "correlation"}, scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
public static class NullableBigIntCorrelation implements AggrFunction{

  @Param NullableBigIntHolder xIn;
  @Param NullableBigIntHolder yIn;

  @Workspace Float8Holder xMean;
  @Workspace Float8Holder yMean;
  @Workspace Float8Holder xyMean;

  @Workspace Float8Holder xDev;
  @Workspace Float8Holder yDev;

  @Workspace Float8Holder covar;

  @Workspace BigIntHolder count;
  @Output NullableFloat8Holder out;

  public void setup() {
    xMean = new Float8Holder();
    yMean = new Float8Holder();
    xyMean = new Float8Holder();
    xDev = new Float8Holder();
    yDev = new Float8Holder();
    count = new BigIntHolder();
    covar = new Float8Holder();

    // Initialize the workspace variables
    xMean.value = 0;
    yMean.value = 0;
    xyMean.value = 0;
    xDev.value = 0;
    yDev.value = 0;
    count.value = 1;
    covar.value = 0;
  }

  @Override
  public void add() {
	  sout: {
	  if (xIn.isSet == 0 || yIn.isSet == 0) {
	   // processing nullable input and the value is null, so don't do anything...
	   break sout;
	  }

    // compute covariance
	double xOldMean = xMean.value, yOldMean = yMean.value;

    xMean.value += ((xIn.value - xMean.value) / count.value);
    yMean.value += ((yIn.value - yMean.value) / count.value);

    xDev.value += (xIn.value - xOldMean) * (xIn.value - xMean.value);
    yDev.value += (yIn.value - yOldMean) * (yIn.value - yMean.value);

    xyMean.value += ((xIn.value * yIn.value) - xyMean.value) / count.value;
    count.value++;
    } // end of sout block
  }

  @Override
  public void output() {
    double xVariance = (xDev.value / (count.value - 1));
    double yVariance = (yDev.value / (count.value - 1));
    double xyCovariance = (xyMean.value - (xMean.value * yMean.value));

    out.isSet = 1;
    out.value = xyCovariance / Math.sqrt((xVariance * yVariance));
  }

  @Override
  public void reset() {
    xMean.value = 0;
    yMean.value = 0;
    xyMean.value = 0;
    count.value = 1;
    covar.value = 0;
  }
}



@FunctionTemplate(names = {"corr", "correlation"}, scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
public static class NullableIntCorrelation implements AggrFunction{

  @Param NullableIntHolder xIn;
  @Param NullableIntHolder yIn;

  @Workspace Float8Holder xMean;
  @Workspace Float8Holder yMean;
  @Workspace Float8Holder xyMean;

  @Workspace Float8Holder xDev;
  @Workspace Float8Holder yDev;

  @Workspace Float8Holder covar;

  @Workspace BigIntHolder count;
  @Output NullableFloat8Holder out;

  public void setup() {
    xMean = new Float8Holder();
    yMean = new Float8Holder();
    xyMean = new Float8Holder();
    xDev = new Float8Holder();
    yDev = new Float8Holder();
    count = new BigIntHolder();
    covar = new Float8Holder();

    // Initialize the workspace variables
    xMean.value = 0;
    yMean.value = 0;
    xyMean.value = 0;
    xDev.value = 0;
    yDev.value = 0;
    count.value = 1;
    covar.value = 0;
  }

  @Override
  public void add() {
	  sout: {
	  if (xIn.isSet == 0 || yIn.isSet == 0) {
	   // processing nullable input and the value is null, so don't do anything...
	   break sout;
	  }

    // compute covariance
	double xOldMean = xMean.value, yOldMean = yMean.value;

    xMean.value += ((xIn.value - xMean.value) / count.value);
    yMean.value += ((yIn.value - yMean.value) / count.value);

    xDev.value += (xIn.value - xOldMean) * (xIn.value - xMean.value);
    yDev.value += (yIn.value - yOldMean) * (yIn.value - yMean.value);

    xyMean.value += ((xIn.value * yIn.value) - xyMean.value) / count.value;
    count.value++;
    } // end of sout block
  }

  @Override
  public void output() {
    double xVariance = (xDev.value / (count.value - 1));
    double yVariance = (yDev.value / (count.value - 1));
    double xyCovariance = (xyMean.value - (xMean.value * yMean.value));

    out.isSet = 1;
    out.value = xyCovariance / Math.sqrt((xVariance * yVariance));
  }

  @Override
  public void reset() {
    xMean.value = 0;
    yMean.value = 0;
    xyMean.value = 0;
    count.value = 1;
    covar.value = 0;
  }
}



@FunctionTemplate(names = {"corr", "correlation"}, scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
public static class NullableFloat4Correlation implements AggrFunction{

  @Param NullableFloat4Holder xIn;
  @Param NullableFloat4Holder yIn;

  @Workspace Float8Holder xMean;
  @Workspace Float8Holder yMean;
  @Workspace Float8Holder xyMean;

  @Workspace Float8Holder xDev;
  @Workspace Float8Holder yDev;

  @Workspace Float8Holder covar;

  @Workspace BigIntHolder count;
  @Output NullableFloat8Holder out;

  public void setup() {
    xMean = new Float8Holder();
    yMean = new Float8Holder();
    xyMean = new Float8Holder();
    xDev = new Float8Holder();
    yDev = new Float8Holder();
    count = new BigIntHolder();
    covar = new Float8Holder();

    // Initialize the workspace variables
    xMean.value = 0;
    yMean.value = 0;
    xyMean.value = 0;
    xDev.value = 0;
    yDev.value = 0;
    count.value = 1;
    covar.value = 0;
  }

  @Override
  public void add() {
	  sout: {
	  if (xIn.isSet == 0 || yIn.isSet == 0) {
	   // processing nullable input and the value is null, so don't do anything...
	   break sout;
	  }

    // compute covariance
	double xOldMean = xMean.value, yOldMean = yMean.value;

    xMean.value += ((xIn.value - xMean.value) / count.value);
    yMean.value += ((yIn.value - yMean.value) / count.value);

    xDev.value += (xIn.value - xOldMean) * (xIn.value - xMean.value);
    yDev.value += (yIn.value - yOldMean) * (yIn.value - yMean.value);

    xyMean.value += ((xIn.value * yIn.value) - xyMean.value) / count.value;
    count.value++;
    } // end of sout block
  }

  @Override
  public void output() {
    double xVariance = (xDev.value / (count.value - 1));
    double yVariance = (yDev.value / (count.value - 1));
    double xyCovariance = (xyMean.value - (xMean.value * yMean.value));

    out.isSet = 1;
    out.value = xyCovariance / Math.sqrt((xVariance * yVariance));
  }

  @Override
  public void reset() {
    xMean.value = 0;
    yMean.value = 0;
    xyMean.value = 0;
    count.value = 1;
    covar.value = 0;
  }
}



@FunctionTemplate(names = {"corr", "correlation"}, scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
public static class NullableFloat8Correlation implements AggrFunction{

  @Param NullableFloat8Holder xIn;
  @Param NullableFloat8Holder yIn;

  @Workspace Float8Holder xMean;
  @Workspace Float8Holder yMean;
  @Workspace Float8Holder xyMean;

  @Workspace Float8Holder xDev;
  @Workspace Float8Holder yDev;

  @Workspace Float8Holder covar;

  @Workspace BigIntHolder count;
  @Output NullableFloat8Holder out;

  public void setup() {
    xMean = new Float8Holder();
    yMean = new Float8Holder();
    xyMean = new Float8Holder();
    xDev = new Float8Holder();
    yDev = new Float8Holder();
    count = new BigIntHolder();
    covar = new Float8Holder();

    // Initialize the workspace variables
    xMean.value = 0;
    yMean.value = 0;
    xyMean.value = 0;
    xDev.value = 0;
    yDev.value = 0;
    count.value = 1;
    covar.value = 0;
  }

  @Override
  public void add() {
	  sout: {
	  if (xIn.isSet == 0 || yIn.isSet == 0) {
	   // processing nullable input and the value is null, so don't do anything...
	   break sout;
	  }

    // compute covariance
	double xOldMean = xMean.value, yOldMean = yMean.value;

    xMean.value += ((xIn.value - xMean.value) / count.value);
    yMean.value += ((yIn.value - yMean.value) / count.value);

    xDev.value += (xIn.value - xOldMean) * (xIn.value - xMean.value);
    yDev.value += (yIn.value - yOldMean) * (yIn.value - yMean.value);

    xyMean.value += ((xIn.value * yIn.value) - xyMean.value) / count.value;
    count.value++;
    } // end of sout block
  }

  @Override
  public void output() {
    double xVariance = (xDev.value / (count.value - 1));
    double yVariance = (yDev.value / (count.value - 1));
    double xyCovariance = (xyMean.value - (xMean.value * yMean.value));

    out.isSet = 1;
    out.value = xyCovariance / Math.sqrt((xVariance * yVariance));
  }

  @Override
  public void reset() {
    xMean.value = 0;
    yMean.value = 0;
    xyMean.value = 0;
    count.value = 1;
    covar.value = 0;
  }
}


}
