

// Source code generated using FreeMarker template DateIntervalAggrFunctions1.java


package com.dremio.exec.expr.fn.impl.gaggr;

import com.dremio.exec.expr.AggrFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.FunctionScope;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.annotations.Workspace;
import org.apache.arrow.vector.holders.*;

@SuppressWarnings("unused")

/**
 * generated from DateIntervalAggrFunctions1.java Min
 */
public class MinDateTypeFunctions {

@FunctionTemplate(name = "min", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
public static class NullableDateMilliMin implements AggrFunction{

  @Param NullableDateMilliHolder in;
  @Workspace NullableDateMilliHolder value;
  @Workspace NullableBigIntHolder nonNullCount;
  @Output NullableDateMilliHolder out;

  public void setup() {
	  value = new NullableDateMilliHolder();
    nonNullCount = new NullableBigIntHolder();
    nonNullCount.value = 0;
    value.value = Long.MAX_VALUE;
  }

  @Override
  public void add() {
	    sout: {
	    if (in.isSet == 0) {
		    // processing nullable input and the value is null, so don't do anything...
		    break sout;
	    }
    nonNullCount.value = 1;

    value.value = Math.min(value.value, in.value);
    } // end of sout block
  }

  @Override
  public void output() {
    if (nonNullCount.value > 0) {
      out.isSet = 1;
      out.value = value.value;
    } else {
      out.isSet = 0;
    }
  }

  @Override
  public void reset() {
    nonNullCount.value = 0;
    value.value = Long.MAX_VALUE;
  }

 }

@FunctionTemplate(name = "min", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
public static class NullableTimeStampMilliMin implements AggrFunction{

  @Param NullableTimeStampMilliHolder in;
  @Workspace NullableTimeStampMilliHolder value;
  @Workspace NullableBigIntHolder nonNullCount;
  @Output NullableTimeStampMilliHolder out;

  public void setup() {
	  value = new NullableTimeStampMilliHolder();
    nonNullCount = new NullableBigIntHolder();
    nonNullCount.value = 0;
    value.value = Long.MAX_VALUE;
  }

  @Override
  public void add() {
	    sout: {
	    if (in.isSet == 0) {
		    // processing nullable input and the value is null, so don't do anything...
		    break sout;
	    }
    nonNullCount.value = 1;

    value.value = Math.min(value.value, in.value);
    } // end of sout block
  }

  @Override
  public void output() {
    if (nonNullCount.value > 0) {
      out.isSet = 1;
      out.value = value.value;
    } else {
      out.isSet = 0;
    }
  }

  @Override
  public void reset() {
    nonNullCount.value = 0;
    value.value = Long.MAX_VALUE;
  }

 }

@FunctionTemplate(name = "min", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
public static class NullableTimeMilliMin implements AggrFunction{

  @Param NullableTimeMilliHolder in;
  @Workspace NullableTimeMilliHolder value;
  @Workspace NullableBigIntHolder nonNullCount;
  @Output NullableTimeMilliHolder out;

  public void setup() {
	  value = new NullableTimeMilliHolder();
    nonNullCount = new NullableBigIntHolder();
    nonNullCount.value = 0;
    value.value = Integer.MAX_VALUE;
  }

  @Override
  public void add() {
	    sout: {
	    if (in.isSet == 0) {
		    // processing nullable input and the value is null, so don't do anything...
		    break sout;
	    }
    nonNullCount.value = 1;

    value.value = Math.min(value.value, in.value);
    } // end of sout block
  }

  @Override
  public void output() {
    if (nonNullCount.value > 0) {
      out.isSet = 1;
      out.value = value.value;
    } else {
      out.isSet = 0;
    }
  }

  @Override
  public void reset() {
    nonNullCount.value = 0;
    value.value = Integer.MAX_VALUE;
  }

 }

@FunctionTemplate(name = "min", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
public static class NullableIntervalDayMin implements AggrFunction{

  @Param NullableIntervalDayHolder in;
  @Workspace NullableBigIntHolder value;
  @Workspace NullableBigIntHolder nonNullCount;
  @Output NullableIntervalDayHolder out;

  public void setup() {
	  value = new NullableBigIntHolder();
    nonNullCount = new NullableBigIntHolder();
    nonNullCount.value = 0;
    value.value = Long.MAX_VALUE;
  }

  @Override
  public void add() {
	    sout: {
	    if (in.isSet == 0) {
		    // processing nullable input and the value is null, so don't do anything...
		    break sout;
	    }
    nonNullCount.value = 1;

    long inMS = (long) in.days * (org.apache.arrow.vector.util.DateUtility.daysToStandardMillis) +
                       in.milliseconds;

    value.value = Math.min(value.value, inMS);


    } // end of sout block
  }

  @Override
  public void output() {
    if (nonNullCount.value > 0) {
      out.isSet = 1;
      out.days = (int) (value.value / org.apache.arrow.vector.util.DateUtility.daysToStandardMillis);
      out.milliseconds = (int) (value.value % org.apache.arrow.vector.util.DateUtility.daysToStandardMillis);
    } else {
      out.isSet = 0;
    }
  }

  @Override
  public void reset() {
    nonNullCount.value = 0;
    value.value = Long.MAX_VALUE;
  }

 }

@FunctionTemplate(name = "min", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
public static class NullableIntervalYearMin implements AggrFunction{

  @Param NullableIntervalYearHolder in;
  @Workspace NullableIntervalYearHolder value;
  @Workspace NullableBigIntHolder nonNullCount;
  @Output NullableIntervalYearHolder out;

  public void setup() {
	  value = new NullableIntervalYearHolder();
    nonNullCount = new NullableBigIntHolder();
    nonNullCount.value = 0;
    value.value = Integer.MAX_VALUE;
  }

  @Override
  public void add() {
	    sout: {
	    if (in.isSet == 0) {
		    // processing nullable input and the value is null, so don't do anything...
		    break sout;
	    }
    nonNullCount.value = 1;

    value.value = Math.min(value.value, in.value);
    } // end of sout block
  }

  @Override
  public void output() {
    if (nonNullCount.value > 0) {
      out.isSet = 1;
      out.value = value.value;
    } else {
      out.isSet = 0;
    }
  }

  @Override
  public void reset() {
    nonNullCount.value = 0;
    value.value = Integer.MAX_VALUE;
  }

 }

}
