

// Source code generated using FreeMarker template AggrTypeFunctions1.java


package com.dremio.exec.expr.fn.impl.gaggr;

import com.dremio.exec.expr.AggrFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.FunctionScope;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.annotations.Workspace;
import org.apache.arrow.vector.holders.*;

@SuppressWarnings("unused")
/**
 * generated from AggrTypeFunctions1.java 
 */
public class MinFunctions {
	static final org.slf4j.Logger logger = org.slf4j.LoggerFactory.getLogger(MinFunctions.class);


@FunctionTemplate(name = "min", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
public static class NullableBitMin implements AggrFunction{

  @Param NullableBitHolder in;
  @Workspace NullableBitHolder value;
  @Workspace NullableBigIntHolder nonNullCount;
  @Output NullableBitHolder out;

  public void setup() {
	  value = new NullableBitHolder();
	  value.isSet = 1;
	  nonNullCount = new NullableBigIntHolder();
	  nonNullCount.isSet = 1;
	  nonNullCount.value = 0;
      value.value = 1;
	  
  }
  
  @Override
  public void add() {
	    sout: {
	    if (in.isSet == 0) {
		    // processing nullable input and the value is null, so don't do anything...
		    break sout;
	    }
    nonNullCount.value = 1;
	    value.value = Math.min(value.value, in.value);
    } // end of sout block
  }

  @Override
  public void output() {   
    if (nonNullCount.value > 0) {
      out.value = value.value;
      out.isSet = 1;
    } else {
      out.isSet = 0;
    }
  }

  @Override
  public void reset() {
    nonNullCount.value = 0;
	  
  }
 
 }


@FunctionTemplate(name = "min", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
public static class NullableIntMin implements AggrFunction{

  @Param NullableIntHolder in;
  @Workspace NullableIntHolder value;
  @Workspace NullableBigIntHolder nonNullCount;
  @Output NullableIntHolder out;

  public void setup() {
	  value = new NullableIntHolder();
	  value.isSet = 1;
	  nonNullCount = new NullableBigIntHolder();
	  nonNullCount.isSet = 1;
	  nonNullCount.value = 0;
	    value.value = Integer.MAX_VALUE;
	  
  }
  
  @Override
  public void add() {
	    sout: {
	    if (in.isSet == 0) {
		    // processing nullable input and the value is null, so don't do anything...
		    break sout;
	    }
    nonNullCount.value = 1;
	    value.value = Math.min(value.value, in.value);
    } // end of sout block
  }

  @Override
  public void output() {   
    if (nonNullCount.value > 0) {
      out.value = value.value;
      out.isSet = 1;
    } else {
      out.isSet = 0;
    }
  }

  @Override
  public void reset() {
    nonNullCount.value = 0;
	    value.value = Integer.MAX_VALUE;
	  
  }
 
 }


@FunctionTemplate(name = "min", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
public static class NullableBigIntMin implements AggrFunction{

  @Param NullableBigIntHolder in;
  @Workspace NullableBigIntHolder value;
  @Workspace NullableBigIntHolder nonNullCount;
  @Output NullableBigIntHolder out;

  public void setup() {
	  value = new NullableBigIntHolder();
	  value.isSet = 1;
	  nonNullCount = new NullableBigIntHolder();
	  nonNullCount.isSet = 1;
	  nonNullCount.value = 0;
	    value.value = Long.MAX_VALUE;
	  
  }
  
  @Override
  public void add() {
	    sout: {
	    if (in.isSet == 0) {
		    // processing nullable input and the value is null, so don't do anything...
		    break sout;
	    }
    nonNullCount.value = 1;
	    value.value = Math.min(value.value, in.value);
    } // end of sout block
  }

  @Override
  public void output() {   
    if (nonNullCount.value > 0) {
      out.value = value.value;
      out.isSet = 1;
    } else {
      out.isSet = 0;
    }
  }

  @Override
  public void reset() {
    nonNullCount.value = 0;
	    value.value = Long.MAX_VALUE;
	  
  }
 
 }


@FunctionTemplate(name = "min", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
public static class NullableFloat4Min implements AggrFunction{

  @Param NullableFloat4Holder in;
  @Workspace NullableFloat4Holder value;
  @Workspace NullableBigIntHolder nonNullCount;
  @Output NullableFloat4Holder out;

  public void setup() {
	  value = new NullableFloat4Holder();
	  value.isSet = 1;
	  nonNullCount = new NullableBigIntHolder();
	  nonNullCount.isSet = 1;
	  nonNullCount.value = 0;
		  value.value = Float.MAX_VALUE;
	  
  }
  
  @Override
  public void add() {
	    sout: {
	    if (in.isSet == 0) {
		    // processing nullable input and the value is null, so don't do anything...
		    break sout;
	    }
    nonNullCount.value = 1;
	    value.value = Math.min(value.value, in.value);
    } // end of sout block
  }

  @Override
  public void output() {   
    if (nonNullCount.value > 0) {
      out.value = value.value;
      out.isSet = 1;
    } else {
      out.isSet = 0;
    }
  }

  @Override
  public void reset() {
    nonNullCount.value = 0;
		value.value = Float.MAX_VALUE;
	  
  }
 
 }


@FunctionTemplate(name = "min", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
public static class NullableFloat8Min implements AggrFunction{

  @Param NullableFloat8Holder in;
  @Workspace NullableFloat8Holder value;
  @Workspace NullableBigIntHolder nonNullCount;
  @Output NullableFloat8Holder out;

  public void setup() {
	  value = new NullableFloat8Holder();
	  value.isSet = 1;
	  nonNullCount = new NullableBigIntHolder();
	  nonNullCount.isSet = 1;
	  nonNullCount.value = 0;
		  value.value = Double.MAX_VALUE;	    
	  
  }
  
  @Override
  public void add() {
	    sout: {
	    if (in.isSet == 0) {
		    // processing nullable input and the value is null, so don't do anything...
		    break sout;
	    }
    nonNullCount.value = 1;
	    value.value = Math.min(value.value, in.value);
    } // end of sout block
  }

  @Override
  public void output() {   
    if (nonNullCount.value > 0) {
      out.value = value.value;
      out.isSet = 1;
    } else {
      out.isSet = 0;
    }
  }

  @Override
  public void reset() {
    nonNullCount.value = 0;
		value.value = Double.MAX_VALUE;	    
	  
  }
 
 }

}
