

// Source code generated using FreeMarker template SingleValueAggregateFunctions.java

package com.dremio.exec.expr.fn.impl.gaggr;

import com.dremio.exec.expr.AggrFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.FunctionScope;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.annotations.Workspace;
import com.dremio.exec.expr.fn.FunctionErrorContext;
import javax.inject.Inject;
import org.apache.arrow.vector.holders.*;

@SuppressWarnings("unused")
/**
 * generated from SingleValueAggregateFunctions.java 
 */
public class SingleValueFunctions {
  @FunctionTemplate(name = "single_value", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
  public static class IntSingleValueFunction implements AggrFunction {

    @Param NullableIntHolder in;
    @Workspace NullableIntHolder value;
    @Workspace IntHolder isSet;
    @Output NullableIntHolder out;
    @Inject FunctionErrorContext errCtx;

    @Override
    public void setup() {
      isSet.value = 0;
    }

    @Override
    public void add() {
      if (isSet.value == 1) {
        throw errCtx.error()
          .message("Subqueries used in expressions must be scalar (must return a single value).")
          .build();
      }
      isSet.value = 1;
      value.isSet = in.isSet;
        value.value = in.value;
    }

    @Override
    public void output() {
      out.isSet = value.isSet;
        out.value = value.value;
    }

    @Override
    public void reset() {
        value.value = 0;
      value.isSet = 0;
      isSet.value = 0;
    }
  }
  @FunctionTemplate(name = "single_value", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
  public static class BigIntSingleValueFunction implements AggrFunction {

    @Param NullableBigIntHolder in;
    @Workspace NullableBigIntHolder value;
    @Workspace IntHolder isSet;
    @Output NullableBigIntHolder out;
    @Inject FunctionErrorContext errCtx;

    @Override
    public void setup() {
      isSet.value = 0;
    }

    @Override
    public void add() {
      if (isSet.value == 1) {
        throw errCtx.error()
          .message("Subqueries used in expressions must be scalar (must return a single value).")
          .build();
      }
      isSet.value = 1;
      value.isSet = in.isSet;
        value.value = in.value;
    }

    @Override
    public void output() {
      out.isSet = value.isSet;
        out.value = value.value;
    }

    @Override
    public void reset() {
        value.value = 0;
      value.isSet = 0;
      isSet.value = 0;
    }
  }
  @FunctionTemplate(name = "single_value", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
  public static class Float4SingleValueFunction implements AggrFunction {

    @Param NullableFloat4Holder in;
    @Workspace NullableFloat4Holder value;
    @Workspace IntHolder isSet;
    @Output NullableFloat4Holder out;
    @Inject FunctionErrorContext errCtx;

    @Override
    public void setup() {
      isSet.value = 0;
    }

    @Override
    public void add() {
      if (isSet.value == 1) {
        throw errCtx.error()
          .message("Subqueries used in expressions must be scalar (must return a single value).")
          .build();
      }
      isSet.value = 1;
      value.isSet = in.isSet;
        value.value = in.value;
    }

    @Override
    public void output() {
      out.isSet = value.isSet;
        out.value = value.value;
    }

    @Override
    public void reset() {
        value.value = 0;
      value.isSet = 0;
      isSet.value = 0;
    }
  }
  @FunctionTemplate(name = "single_value", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
  public static class Float8SingleValueFunction implements AggrFunction {

    @Param NullableFloat8Holder in;
    @Workspace NullableFloat8Holder value;
    @Workspace IntHolder isSet;
    @Output NullableFloat8Holder out;
    @Inject FunctionErrorContext errCtx;

    @Override
    public void setup() {
      isSet.value = 0;
    }

    @Override
    public void add() {
      if (isSet.value == 1) {
        throw errCtx.error()
          .message("Subqueries used in expressions must be scalar (must return a single value).")
          .build();
      }
      isSet.value = 1;
      value.isSet = in.isSet;
        value.value = in.value;
    }

    @Override
    public void output() {
      out.isSet = value.isSet;
        out.value = value.value;
    }

    @Override
    public void reset() {
        value.value = 0;
      value.isSet = 0;
      isSet.value = 0;
    }
  }
  @FunctionTemplate(name = "single_value", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
  public static class VarCharSingleValueFunction implements AggrFunction {

    @Param NullableVarCharHolder in;
    @Workspace NullableVarCharHolder value;
    @Workspace IntHolder isSet;
    @Output NullableVarCharHolder out;
    @Inject FunctionErrorContext errCtx;

    @Override
    public void setup() {
      isSet.value = 0;
    }

    @Override
    public void add() {
      if (isSet.value == 1) {
        throw errCtx.error()
          .message("Subqueries used in expressions must be scalar (must return a single value).")
          .build();
      }
      isSet.value = 1;
      value.isSet = in.isSet;
        value.start = in.start;
        value.end = in.end;
        value.buffer = in.buffer;
    }

    @Override
    public void output() {
      out.isSet = value.isSet;
        out.start = value.start;
        out.end = value.end;
        out.buffer = value.buffer;
    }

    @Override
    public void reset() {
        value.start = 0;
        value.end = 0;
        value.buffer = null;
      value.isSet = 0;
      isSet.value = 0;
    }
  }
  @FunctionTemplate(name = "single_value", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
  public static class VarBinarySingleValueFunction implements AggrFunction {

    @Param NullableVarBinaryHolder in;
    @Workspace NullableVarBinaryHolder value;
    @Workspace IntHolder isSet;
    @Output NullableVarBinaryHolder out;
    @Inject FunctionErrorContext errCtx;

    @Override
    public void setup() {
      isSet.value = 0;
    }

    @Override
    public void add() {
      if (isSet.value == 1) {
        throw errCtx.error()
          .message("Subqueries used in expressions must be scalar (must return a single value).")
          .build();
      }
      isSet.value = 1;
      value.isSet = in.isSet;
        value.start = in.start;
        value.end = in.end;
        value.buffer = in.buffer;
    }

    @Override
    public void output() {
      out.isSet = value.isSet;
        out.start = value.start;
        out.end = value.end;
        out.buffer = value.buffer;
    }

    @Override
    public void reset() {
        value.start = 0;
        value.end = 0;
        value.buffer = null;
      value.isSet = 0;
      isSet.value = 0;
    }
  }
  @FunctionTemplate(name = "single_value", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
  public static class DateMilliSingleValueFunction implements AggrFunction {

    @Param NullableDateMilliHolder in;
    @Workspace NullableDateMilliHolder value;
    @Workspace IntHolder isSet;
    @Output NullableDateMilliHolder out;
    @Inject FunctionErrorContext errCtx;

    @Override
    public void setup() {
      isSet.value = 0;
    }

    @Override
    public void add() {
      if (isSet.value == 1) {
        throw errCtx.error()
          .message("Subqueries used in expressions must be scalar (must return a single value).")
          .build();
      }
      isSet.value = 1;
      value.isSet = in.isSet;
        value.value = in.value;
    }

    @Override
    public void output() {
      out.isSet = value.isSet;
        out.value = value.value;
    }

    @Override
    public void reset() {
        value.value = 0;
      value.isSet = 0;
      isSet.value = 0;
    }
  }
  @FunctionTemplate(name = "single_value", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
  public static class TimeStampMilliSingleValueFunction implements AggrFunction {

    @Param NullableTimeStampMilliHolder in;
    @Workspace NullableTimeStampMilliHolder value;
    @Workspace IntHolder isSet;
    @Output NullableTimeStampMilliHolder out;
    @Inject FunctionErrorContext errCtx;

    @Override
    public void setup() {
      isSet.value = 0;
    }

    @Override
    public void add() {
      if (isSet.value == 1) {
        throw errCtx.error()
          .message("Subqueries used in expressions must be scalar (must return a single value).")
          .build();
      }
      isSet.value = 1;
      value.isSet = in.isSet;
        value.value = in.value;
    }

    @Override
    public void output() {
      out.isSet = value.isSet;
        out.value = value.value;
    }

    @Override
    public void reset() {
        value.value = 0;
      value.isSet = 0;
      isSet.value = 0;
    }
  }
  @FunctionTemplate(name = "single_value", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
  public static class TimeMilliSingleValueFunction implements AggrFunction {

    @Param NullableTimeMilliHolder in;
    @Workspace NullableTimeMilliHolder value;
    @Workspace IntHolder isSet;
    @Output NullableTimeMilliHolder out;
    @Inject FunctionErrorContext errCtx;

    @Override
    public void setup() {
      isSet.value = 0;
    }

    @Override
    public void add() {
      if (isSet.value == 1) {
        throw errCtx.error()
          .message("Subqueries used in expressions must be scalar (must return a single value).")
          .build();
      }
      isSet.value = 1;
      value.isSet = in.isSet;
        value.value = in.value;
    }

    @Override
    public void output() {
      out.isSet = value.isSet;
        out.value = value.value;
    }

    @Override
    public void reset() {
        value.value = 0;
      value.isSet = 0;
      isSet.value = 0;
    }
  }
  @FunctionTemplate(name = "single_value", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
  public static class IntervalDaySingleValueFunction implements AggrFunction {

    @Param NullableIntervalDayHolder in;
    @Workspace NullableIntervalDayHolder value;
    @Workspace IntHolder isSet;
    @Output NullableIntervalDayHolder out;
    @Inject FunctionErrorContext errCtx;

    @Override
    public void setup() {
      isSet.value = 0;
    }

    @Override
    public void add() {
      if (isSet.value == 1) {
        throw errCtx.error()
          .message("Subqueries used in expressions must be scalar (must return a single value).")
          .build();
      }
      isSet.value = 1;
      value.isSet = in.isSet;
        value.days = in.days;
        value.milliseconds = in.milliseconds;
    }

    @Override
    public void output() {
      out.isSet = value.isSet;
        out.days = value.days;
        out.milliseconds = value.milliseconds;
    }

    @Override
    public void reset() {
        value.days = 0;
        value.milliseconds = 0;
      value.isSet = 0;
      isSet.value = 0;
    }
  }
  @FunctionTemplate(name = "single_value", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
  public static class IntervalYearSingleValueFunction implements AggrFunction {

    @Param NullableIntervalYearHolder in;
    @Workspace NullableIntervalYearHolder value;
    @Workspace IntHolder isSet;
    @Output NullableIntervalYearHolder out;
    @Inject FunctionErrorContext errCtx;

    @Override
    public void setup() {
      isSet.value = 0;
    }

    @Override
    public void add() {
      if (isSet.value == 1) {
        throw errCtx.error()
          .message("Subqueries used in expressions must be scalar (must return a single value).")
          .build();
      }
      isSet.value = 1;
      value.isSet = in.isSet;
        value.value = in.value;
    }

    @Override
    public void output() {
      out.isSet = value.isSet;
        out.value = value.value;
    }

    @Override
    public void reset() {
        value.value = 0;
      value.isSet = 0;
      isSet.value = 0;
    }
  }
}
