

// Source code generated using FreeMarker template DateIntervalAggrFunctions1.java


package com.dremio.exec.expr.fn.impl.gaggr;

import com.dremio.exec.expr.AggrFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.FunctionScope;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.annotations.Workspace;
import org.apache.arrow.vector.holders.*;

@SuppressWarnings("unused")

/**
 * generated from DateIntervalAggrFunctions1.java Sum
 */
public class SumDateTypeFunctions {

@FunctionTemplate(name = "sum", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
public static class NullableIntervalDaySum implements AggrFunction{

  @Param NullableIntervalDayHolder in;
  @Workspace NullableIntervalDayHolder value;
  @Workspace NullableBigIntHolder nonNullCount;
  @Output NullableIntervalDayHolder out;

  public void setup() {
	  value = new NullableIntervalDayHolder();
    nonNullCount = new NullableBigIntHolder();
    nonNullCount.value = 0;
    value.days= 0;
    value.milliseconds = 0;
  }

  @Override
  public void add() {
	    sout: {
	    if (in.isSet == 0) {
		    // processing nullable input and the value is null, so don't do anything...
		    break sout;
	    }
    nonNullCount.value = 1;
    value.days += in.days;
    value.milliseconds += in.milliseconds;
    } // end of sout block
  }

  @Override
  public void output() {
    if (nonNullCount.value > 0) {
      out.isSet = 1;
      out.days = value.days;
      out.milliseconds = value.milliseconds;
    } else {
      out.isSet = 0;
    }
  }

  @Override
  public void reset() {
    nonNullCount.value = 0;
    value.days= 0;
    value.milliseconds = 0;
  }

 }

@FunctionTemplate(name = "sum", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)
public static class NullableIntervalYearSum implements AggrFunction{

  @Param NullableIntervalYearHolder in;
  @Workspace NullableIntervalYearHolder value;
  @Workspace NullableBigIntHolder nonNullCount;
  @Output NullableIntervalYearHolder out;

  public void setup() {
	  value = new NullableIntervalYearHolder();
    nonNullCount = new NullableBigIntHolder();
    nonNullCount.value = 0;
    value.value = 0;
  }

  @Override
  public void add() {
	    sout: {
	    if (in.isSet == 0) {
		    // processing nullable input and the value is null, so don't do anything...
		    break sout;
	    }
    nonNullCount.value = 1;
	    value.value += in.value;
    } // end of sout block
  }

  @Override
  public void output() {
    if (nonNullCount.value > 0) {
      out.isSet = 1;
      out.value = value.value;
    } else {
      out.isSet = 0;
    }
  }

  @Override
  public void reset() {
    nonNullCount.value = 0;
    value.value = 0;
  }

 }

}

