

// Source code generated using FreeMarker template AggrTypeFunctions3.java


package com.dremio.exec.expr.fn.impl.gaggr;

import com.dremio.exec.expr.AggrFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.NullHandling;
import com.dremio.exec.expr.annotations.FunctionTemplate.FunctionScope;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.annotations.Workspace;
import org.apache.arrow.vector.holders.*;

@SuppressWarnings("unused")

/**
 * generated from AggrTypeFunctions3.java 
 */
public class VariancePopFunctions {
	static final org.slf4j.Logger logger = org.slf4j.LoggerFactory.getLogger(VariancePopFunctions.class);


@FunctionTemplate(name = "var_pop", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)

public static class NullableBigIntVariancePop implements AggrFunction{

  @Param NullableBigIntHolder in;
  @Workspace Float8Holder avg;
  @Workspace Float8Holder dev;
  @Workspace BigIntHolder count;
  @Workspace NullableBigIntHolder nonNullCount;
  @Output NullableFloat8Holder out;

  public void setup() {
  	avg = new Float8Holder();
  	avg.value = 0;
    dev = new Float8Holder();
    dev.value = 0;
    count = new BigIntHolder();
    count.value = 1;
  	nonNullCount = new NullableBigIntHolder();
  	nonNullCount.value = 0;
  	nonNullCount.isSet = 1;
    // Initialize the workspace variables
  }

  @Override
  public void add() {
	  sout: {
	  if (in.isSet == 0) {
	   // processing nullable input and the value is null, so don't do anything...
	   break sout;
	  }

    nonNullCount.value = 1;
    // Welford's approach to compute standard deviation
    double temp = avg.value;
    avg.value += ((in.value - temp) / count.value);
    dev.value += (in.value - temp) * (in.value - avg.value);
    count.value++;

    } // end of sout block
  }

  @Override
  public void output() {
    if (nonNullCount.value > 0) {
      out.isSet = 1;
      if (count.value  > 1)
        out.value = (dev.value / (count.value - 1));
     } else {
       out.isSet = 0;
    }
  }

  @Override
  public void reset() {
    nonNullCount.value = 0;
    avg.value = 0;
    dev.value = 0;
    count.value = 1;
  }
}



@FunctionTemplate(name = "var_pop", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)

public static class NullableIntVariancePop implements AggrFunction{

  @Param NullableIntHolder in;
  @Workspace Float8Holder avg;
  @Workspace Float8Holder dev;
  @Workspace BigIntHolder count;
  @Workspace NullableBigIntHolder nonNullCount;
  @Output NullableFloat8Holder out;

  public void setup() {
  	avg = new Float8Holder();
  	avg.value = 0;
    dev = new Float8Holder();
    dev.value = 0;
    count = new BigIntHolder();
    count.value = 1;
  	nonNullCount = new NullableBigIntHolder();
  	nonNullCount.value = 0;
  	nonNullCount.isSet = 1;
    // Initialize the workspace variables
  }

  @Override
  public void add() {
	  sout: {
	  if (in.isSet == 0) {
	   // processing nullable input and the value is null, so don't do anything...
	   break sout;
	  }

    nonNullCount.value = 1;
    // Welford's approach to compute standard deviation
    double temp = avg.value;
    avg.value += ((in.value - temp) / count.value);
    dev.value += (in.value - temp) * (in.value - avg.value);
    count.value++;

    } // end of sout block
  }

  @Override
  public void output() {
    if (nonNullCount.value > 0) {
      out.isSet = 1;
      if (count.value  > 1)
        out.value = (dev.value / (count.value - 1));
     } else {
       out.isSet = 0;
    }
  }

  @Override
  public void reset() {
    nonNullCount.value = 0;
    avg.value = 0;
    dev.value = 0;
    count.value = 1;
  }
}



@FunctionTemplate(name = "var_pop", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)

public static class NullableFloat4VariancePop implements AggrFunction{

  @Param NullableFloat4Holder in;
  @Workspace Float8Holder avg;
  @Workspace Float8Holder dev;
  @Workspace BigIntHolder count;
  @Workspace NullableBigIntHolder nonNullCount;
  @Output NullableFloat8Holder out;

  public void setup() {
  	avg = new Float8Holder();
  	avg.value = 0;
    dev = new Float8Holder();
    dev.value = 0;
    count = new BigIntHolder();
    count.value = 1;
  	nonNullCount = new NullableBigIntHolder();
  	nonNullCount.value = 0;
  	nonNullCount.isSet = 1;
    // Initialize the workspace variables
  }

  @Override
  public void add() {
	  sout: {
	  if (in.isSet == 0) {
	   // processing nullable input and the value is null, so don't do anything...
	   break sout;
	  }

    nonNullCount.value = 1;
    // Welford's approach to compute standard deviation
    double temp = avg.value;
    avg.value += ((in.value - temp) / count.value);
    dev.value += (in.value - temp) * (in.value - avg.value);
    count.value++;

    } // end of sout block
  }

  @Override
  public void output() {
    if (nonNullCount.value > 0) {
      out.isSet = 1;
      if (count.value  > 1)
        out.value = (dev.value / (count.value - 1));
     } else {
       out.isSet = 0;
    }
  }

  @Override
  public void reset() {
    nonNullCount.value = 0;
    avg.value = 0;
    dev.value = 0;
    count.value = 1;
  }
}



@FunctionTemplate(name = "var_pop", scope = FunctionTemplate.FunctionScope.POINT_AGGREGATE)

public static class NullableFloat8VariancePop implements AggrFunction{

  @Param NullableFloat8Holder in;
  @Workspace Float8Holder avg;
  @Workspace Float8Holder dev;
  @Workspace BigIntHolder count;
  @Workspace NullableBigIntHolder nonNullCount;
  @Output NullableFloat8Holder out;

  public void setup() {
  	avg = new Float8Holder();
  	avg.value = 0;
    dev = new Float8Holder();
    dev.value = 0;
    count = new BigIntHolder();
    count.value = 1;
  	nonNullCount = new NullableBigIntHolder();
  	nonNullCount.value = 0;
  	nonNullCount.isSet = 1;
    // Initialize the workspace variables
  }

  @Override
  public void add() {
	  sout: {
	  if (in.isSet == 0) {
	   // processing nullable input and the value is null, so don't do anything...
	   break sout;
	  }

    nonNullCount.value = 1;
    // Welford's approach to compute standard deviation
    double temp = avg.value;
    avg.value += ((in.value - temp) / count.value);
    dev.value += (in.value - temp) * (in.value - avg.value);
    count.value++;

    } // end of sout block
  }

  @Override
  public void output() {
    if (nonNullCount.value > 0) {
      out.isSet = 1;
      if (count.value  > 1)
        out.value = (dev.value / (count.value - 1));
     } else {
       out.isSet = 0;
    }
  }

  @Override
  public void reset() {
    nonNullCount.value = 0;
    avg.value = 0;
    dev.value = 0;
    count.value = 1;
  }
}


}
