

package com.dremio.exec.expr.fn.impl.gcast;

import com.dremio.exec.expr.SimpleFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.NullHandling;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import org.apache.arrow.vector.holders.*;
import javax.inject.Inject;
import org.apache.arrow.memory.ArrowBuf;

/**
 * generated from CastFunctions.java Float4 Int Fixed
 */
@SuppressWarnings("unused")
@FunctionTemplate(name = "castINT", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.NULL_IF_NULL)
public class CastFloat4Int implements SimpleFunction{

  @Param Float4Holder in;
  @Output IntHolder out;

  public void setup() {}

  public void eval() {
    boolean sign = (in.value < 0);
    in.value = java.lang.Math.abs(in.value);
    float fractional = in.value % 1;
    int digit = ((int) (fractional * 10));
    int carry = 0;
    if (digit > 4) {
      carry = 1;
    }
    out.value = ((int) in.value) + carry;
    if (sign == true) {
      out.value *= -1;
    }
  }
}

 

