

package com.dremio.exec.expr.fn.impl.gcast;

import io.netty.buffer.ByteBuf;

import com.dremio.exec.expr.SimpleFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.NullHandling;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.annotations.Workspace;
import org.apache.arrow.vector.holders.*;
import javax.inject.Inject;
import org.apache.arrow.memory.ArrowBuf;

/**
 * generated from CastFunctionsTargetVarLen.java Float8 VarChar TargetVarlen
 */
@SuppressWarnings("unused")
@FunctionTemplate(name = "castVARCHAR", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.NULL_IF_NULL)
public class CastFloat8VarChar implements SimpleFunction{

  @Param Float8Holder in;
  @Param BigIntHolder len;
  @Inject ArrowBuf buffer;
  @Output VarCharHolder out;

  public void setup() {
  }

  public void eval() {
    buffer = buffer.reallocIfNeeded((int) len.value);
    String istr = (new Double(in.value)).toString();
    out.buffer = buffer;
    out.start = 0;
    out.end = Math.min((int)len.value, istr.length()); // truncate if target type has length smaller than that of input's string     
    out.buffer.setBytes(0, istr.substring(0,out.end).getBytes());      
  }
}

 

