

package com.dremio.exec.expr.fn.impl.gcast;

import com.dremio.exec.expr.SimpleFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.NullHandling;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.fn.FunctionErrorContext;
import org.apache.arrow.vector.holders.*;
import javax.inject.Inject;
import org.apache.arrow.memory.ArrowBuf;

/**
 * generated from CastFunctionsSrcVarLen.java VarBinary Float8 SrcVarlen
 */
@SuppressWarnings("unused")
@FunctionTemplate(name = "castFLOAT8", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.NULL_IF_NULL)
public class CastVarBinaryFloat8 implements SimpleFunction{

  @Param VarBinaryHolder in;
  @Output Float8Holder out;
  @Inject FunctionErrorContext errCtx;

  public void setup() {}

  public void eval() {
      
      byte[] buf = new byte[in.end - in.start];
      in.buffer.getBytes(in.start, buf, 0, in.end - in.start);
    
      try{
        out.value = Double.parseDouble(new String(buf, com.google.common.base.Charsets.UTF_8));
      } catch (RuntimeException e) {
        throw errCtx.error(e)
          .build();
      }
  }
}

 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 

