

package com.dremio.exec.expr.fn.impl.gcast;

import io.netty.buffer.ByteBuf;

import com.dremio.exec.expr.SimpleFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.FunctionCostCategory;
import com.dremio.exec.expr.annotations.FunctionTemplate.NullHandling;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.fn.FunctionErrorContext;
import org.apache.arrow.vector.holders.*;
import org.joda.time.DateTimeZone;
import org.joda.time.DateMidnight;
import com.dremio.common.util.JodaDateUtility;
import javax.inject.Inject;
import org.apache.arrow.memory.ArrowBuf;

/**
 * generated from CastVarCharDate.java VarBinary TimeMilli VarBinaryDate
 */
@SuppressWarnings("unused")
@FunctionTemplate(names = {"castTIME", "timetype"}, scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.NULL_IF_NULL, 
  costCategory = FunctionCostCategory.COMPLEX)
public class CastVarBinaryToTimeMilli implements SimpleFunction {

  @Param VarBinaryHolder in;
  @Output TimeMilliHolder out;
  @Inject FunctionErrorContext errCtx;

  public void setup() {
  }

  public void eval() {

      byte[] buf = new byte[in.end - in.start];
      in.buffer.getBytes(in.start, buf, 0, in.end - in.start);
      String input = new String(buf, com.google.common.base.Charsets.UTF_8);

      try {
        org.joda.time.format.DateTimeFormatter f = com.dremio.common.util.JodaDateUtility.getTimeFormatter();
        if (input.length() == 5) {
          input += ":00";
        }
        out.value = (int) com.dremio.common.util.DateTimes.toMillis((f.parseLocalDateTime(input)));
      } catch (RuntimeException e) {
        throw errCtx.error(e)
          .build();
      }

  }
}
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
