

package com.dremio.exec.expr.fn.impl.gcast;

import io.netty.buffer.ByteBuf;

import com.dremio.exec.expr.SimpleFunction;
import com.dremio.exec.expr.annotations.FunctionTemplate;
import com.dremio.exec.expr.annotations.FunctionTemplate.NullHandling;
import com.dremio.exec.expr.annotations.Output;
import com.dremio.exec.expr.annotations.Param;
import com.dremio.exec.expr.annotations.Workspace;
import com.dremio.exec.expr.fn.FunctionErrorContext;
import org.apache.arrow.vector.holders.*;
import org.joda.time.DateTimeZone;
import org.joda.time.DateMidnight;
import org.apache.arrow.vector.util.DateUtility;
import javax.inject.Inject;
import org.apache.arrow.memory.ArrowBuf;

/**
 * generated from CastVarCharInterval.java VarChar IntervalYear VarCharInterval
 */
@SuppressWarnings("unused")
@FunctionTemplate(name = "castINTERVALYEAR", scope = FunctionTemplate.FunctionScope.SIMPLE, nulls=NullHandling.NULL_IF_NULL)
public class CastVarCharToIntervalYear implements SimpleFunction {

  @Param VarCharHolder in;
  @Output IntervalYearHolder out;
  @Inject FunctionErrorContext errCtx;
  @Workspace java.util.regex.Pattern AllNumbers;

  public void setup() {
      AllNumbers = java.util.regex.Pattern.compile("\\d+");
  }

  public void eval() {

      byte[] buf = new byte[in.end - in.start];
      in.buffer.getBytes(in.start, buf, 0, in.end - in.start);
      String input = new String(buf, com.google.common.base.Charsets.UTF_8);

      // Parse the ISO format
      org.joda.time.Period period;
      try {
        if (AllNumbers.matcher(input).matches()) {
          long temp = org.apache.calcite.runtime.SqlFunctions.toLong(input);
          out.value = Math.toIntExact(temp);
          return;
        }
        period = org.joda.time.Period.parse(input);
      } catch (RuntimeException e) {
        throw errCtx.error(e)
          .build();
      }

      out.value = (period.getYears() * org.apache.arrow.vector.util.DateUtility.yearsToMonths) + period.getMonths();
  }
}
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
